Package: rgsepd
Type: Package
Title: Gene Set Enrichment / Projection Displays
Version: 1.42.0
Date: 2022-03-22
Author: Karl Stamm
Maintainer: Karl Stamm <karl.stamm@gmail.com>
Description: R/GSEPD is a bioinformatics package for R to help
        disambiguate transcriptome samples (a matrix of RNA-Seq counts
        at transcript IDs) by automating differential expression (with
        DESeq2), then gene set enrichment (with GOSeq), and finally a
        N-dimensional projection to quantify in which ways each sample
        is like either treatment group. 
Depends: R (>= 4.2.0), DESeq2, goseq (>= 1.28)
Imports: gplots, biomaRt, org.Hs.eg.db, GO.db, SummarizedExperiment,
        AnnotationDbi
Suggests: boot, tools, BiocGenerics, knitr, xtable
License: GPL-3
biocViews: ImmunoOncology, Software, DifferentialExpression,
        GeneSetEnrichment, RNASeq
VignetteBuilder: knitr
git_url: https://git.bioconductor.org/packages/rgsepd
git_branch: RELEASE_3_22
git_last_commit: c033fd6
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29
NeedsCompilation: no
Packaged: 2025-10-30 06:06:09 UTC; biocbuild

README

R/GSEPD or rgsepd is an R package, of Bioconductor style and an abbreviation which expands to Geneset enrichment and Projection Displays. It's a software tool for bioinformatics practicioners and biologists with transcriptome datasets they need help analyzing. 

Automation scripts herein facilitate case/control or two-group comparisons within human RNA-Seq datasets to perform differential expression, geneset overrepresentation, and a novel set/subspace analysis which shows the user how their samples behave relative to each other in a gene-set n-dimensional sense.  See the bioconductor webpage for more information.

https://www.bioconductor.org/packages/release/bioc/html/rgsepd.html

https://bmcbioinformatics.biomedcentral.com/articles/10.1186/s12859-019-2697-5

Copyright 2014-2019 Karl Stamm and Marquette University, but released open source for free scientific usage as GPL3 via Bioconductor.org.  

ExtractProjection <- function(GSEPD, txids, DRAWING=FALSE, GN=c(1,2), PRINTING=FALSE, plotTitle="") {
  
  
  # comparison group sample IDs:
  Group1Set = GSEPD$sampleMeta$Sample[which(GSEPD$sampleMeta$Condition == GSEPD$Conditions[1])]
  Group2Set = GSEPD$sampleMeta$Sample[which(GSEPD$sampleMeta$Condition == GSEPD$Conditions[2])]
  
  #z-score normalization by gene of the samples' normalized counts:
  myPoints <- t(scale( t( GSEPD$normCounts[txids,])))
  
  cols=rep(1,ncol(myPoints))
  pchs=rep(3,ncol(myPoints))
  cols[colnames(myPoints) %in% Group1Set] <- GSEPD$COLORS[1]
  cols[colnames(myPoints) %in% Group2Set] <- GSEPD$COLORS[3]
  pchs[colnames(myPoints) %in% Group1Set] <- 1
  pchs[colnames(myPoints) %in% Group2Set] <- 2
  
  if(PRINTING) {
    print(myPoints)
    print(GN)
    print(Group1Set)
  }
  if(length(Group1Set) > 1)
    AA <- apply(myPoints[,Group1Set],1,mean)#take the mean
  else
    AA <- myPoints[,Group1Set]#take the mean
  if(length(Group2Set)>1)
    AS <- apply(myPoints[,Group2Set],1,mean)
  else
    AS <-  myPoints[,Group2Set]#take the mean
  
  VectorBetween <- (AA - AS)
  uVectorBetween <- VectorBetween/ sqrt(sum(VectorBetween^2)) #unit
  uVectorBetween = as.vector(uVectorBetween)
  #what is the scalar value of each archetype?
  AA.s <- AA %*% uVectorBetween
  AS.s <- AS %*% uVectorBetween 
  
  #then we can easily get the distance to each centroid
  #AA is mean of gene expressions. genes are on the row of myPoints
  Gamma1 <- apply(myPoints , 2, function(x) sqrt(sum(  (x-AA)^2  )))
  Gamma2 <- apply(myPoints , 2, function(x) sqrt(sum(  (x-AS)^2  )))
  #theyre NOT zero-one yet.
  #scale by the distance between them 
  #so it's in units of (AA to AS)
  Gamma1 <- Gamma1 / (sqrt(sum(VectorBetween^2))) ; 
  Gamma2 <- Gamma2 / (sqrt(sum(VectorBetween^2))) ; 
  
  xlim=c(min(AA[GN[1]],min(myPoints[GN[1],]),AS[GN[1]]),
         max(AA[GN[1]],max(myPoints[GN[1],]),AS[GN[1]]))+c(-0.5,0.5)
  ylim=c(min(AA[GN[2]],min(myPoints[GN[2],]),AS[GN[2]]),
         max(AA[GN[2]],max(myPoints[GN[2],]),AS[GN[2]]))+c(-0.5,0.5)
  #each one needs to get projected onto VectorBetween
  alpha=rep(NA,ncol(myPoints)) # a 0-100% scale along the line
  distance_to_line=rep(NA,ncol(myPoints)) #a sample's divergence from the mean/mean line
  
  if(DRAWING==TRUE){
    genenames = c(  DisplayName(txids[GN[1]]) , DisplayName(txids[GN[2]]) )
    plot(cbind(AA, AS)[GN[1],] , cbind(AA, AS)[GN[2],] , type="l", lwd=2,
         xlab=paste(genenames[1],"Z-Score Norm Counts"),
         ylab=paste(genenames[2],"Z-Score Norm Counts"), 
         xlim=xlim, ylim=ylim, main=plotTitle ) 
    text( x=cbind(AA, AS)[GN[1],] , y=cbind(AA, AS)[GN[2],], pos=1, labels=GSEPD$C2T)
    legend("topleft",legend=c(GSEPD$Conditions[1],GSEPD$Conditions[2],"Other"),
           pch=c(1,2,3),col=c(GSEPD$COLORS[1],GSEPD$COLORS[3],1))
  }
  for(i in 1:ncol(myPoints)){ #across people
    scalarProjection <- c((myPoints[,i]-AA) %*% (uVectorBetween))
    scalarProjection <- as.vector(scalarProjection)# new in R 3.5.0
    projected <- scalarProjection * uVectorBetween +AA; 
    distance_to_line[i] <- sqrt(sum( (myPoints[,i] - projected)^2))
    if(DRAWING==TRUE){
      #dots along the line are pch=16
      points(projected[GN[1]],projected[GN[2]], col="black", pch=16);
      points(myPoints[GN[1],i],myPoints[GN[2],i],col=cols[i], pch=pchs[i],cex=2)
      thisGuy <- GSEPD$sampleMeta$SHORTNAME[GSEPD$sampleMeta$Sample==colnames(myPoints)[i]]
      text( x=myPoints[GN[1],i] , y=myPoints[GN[2],i], pos=1, labels=thisGuy,cex=0.5)
    }
    #alpha is the scalar value..
    #now with all these scalars
    #shift their space down by tail and divide out the distance for a 0-100% scale along the line
    alpha[i] <- (scalarProjection - AA.s) / (AS.s-AA.s)
    #theoretically that vector is all zero,zero,zero, one,one,one
  }
  
  #unknown bug has alpha not scaled 0-1. let's do it again.
  alpha_G1 <- mean(alpha[which(colnames(myPoints) %in% Group1Set)]) ;
  alpha=alpha-alpha_G1
  alpha_G2 <- mean(alpha[which(colnames(myPoints) %in% Group2Set)]) ;
  alpha=alpha/alpha_G2
  
  if(DRAWING==TRUE){
    zD <- scale( distance_to_line ) #calculate line styles the same as the white dots on the heatmap
    CF=GSEPD$COLORFUNCTION(100)
    for(i in 1:ncol(myPoints)){ #across people
      scalarProjection <- (myPoints[,i]-AA) %*% (uVectorBetween)
      scalarProjection <- as.vector(scalarProjection)
      projected <- scalarProjection * uVectorBetween + AA; 
      lty=ifelse(zD[i] < GSEPD$VECTOR_DISTANCE_ZTHRESH_Moderate, 1 , 
                 ifelse(zD[i] < GSEPD$VECTOR_DISTANCE_ZTHRESH_Severe, 2 , 3))
      col=CF[cap(round( alpha[i]*100), 1,100 )]
      lines(x=c(projected[GN[1]],myPoints[GN[1],i]), y=c(projected[GN[2]],myPoints[GN[2],i]),lty=lty, col=col)
    }
  }
  
  ValidityScore = Resampled_Significance.k(GSEPD,
                                           ROI=txids,
                                           SOI=c(Group1Set,Group2Set))
  
  x=list();
  x$alpha=alpha
  x$beta=distance_to_line / nrow(myPoints)
  #adding a "gamma" so we can measure the distance to each centroid
  x$gamma1=Gamma1
  x$gamma2=Gamma2
  x$Validity.Score=ValidityScore$Validity
  x$Validity.P=ValidityScore$PV
  x
}

GSEPD_DEGHeatmap <- function(G){
  
  if(!(G$LIMIT$HARD)) { #if the limit is not hard, move it around
    #refilter from full dataset:
    infile=DESEQ_AFile(G)  
    data=read.csv(infile,as.is=TRUE,header=TRUE)
    data=subset(data,!duplicated(data$ENTREZ))
    sdata=subset(data, data$ENTREZ != "NA" & data$baseMean >= G$LIMIT$baseMean)
    DEG=ifelse(sdata$PADJ <= G$LIMIT$PADJ & abs(sdata$LOG2.X.Y.) >= G$LIMIT$LFC , 1,0)
    ToLevel=round((0.0010*length(DEG)))
    PThresh = sort(sdata$PVAL,decreasing=FALSE)[ToLevel]
    if(sum(DEG)<(0.0010*length(DEG))){
      #not enough genes... lets move that PADJ threshold
      DEG=ifelse(sdata$PVAL <= PThresh , 1,0)
      message(sprintf("Not many genes found differentially expressed, (re)moving the significance threshold to raw p=%f so we can use %d genes in the heatmap.",PThresh,sum(DEG)))
    }
    if(G$MAX_Genes_for_Heatmap>nrow(sdata))
      G$MAX_Genes_for_Heatmap=nrow(sdata)
    if(sum(DEG)>G$MAX_Genes_for_Heatmap){
      PThresh = sort(sdata$PVAL,decreasing=FALSE)[G$MAX_Genes_for_Heatmap]
      DEG=ifelse(sdata$PVAL <= PThresh , 1,0)
      message(sprintf("Too many genes found differentially expressed, changing the  threshold to raw p=%f so we can use %d genes in the heatmap.",PThresh,sum(DEG)))
    }
  } else { #else limit is hard: use the pre-generated Annote_Filter file 
    infile=DESEQ_AFFile(G)
    #it's already subsetted:
    sdata=read.csv(infile,as.is=TRUE,header=TRUE)
    #and everything is DEG, by definition:
    DEG= rep(1,nrow(sdata)) 
  }
    
  ROI=sdata$REFSEQ[DEG==1]
  
  plotFile=sprintf("%s/HM.%s.%s.%d.pdf",G$Output_Folder, G$C2T[1],G$C2T[2],sum(DEG))
  Message_Generate(plotFile) #let the user know how we're busy
  if(length(ROI)<2){
    warning("Can't make heatmaps of less than 2 rows. Check your DESEQ result Annote_Filter file.")
    return();
  }
  
  G<-GSEPD_CheckCounts(G)
  fc<-G$normCounts[,G$sampleMeta$Sample] #doublecheck the column order
  
  fc=fc[ROI,] #subset rows
  hmData <- fc
  cellnote=signif(fc,digits=2)
  
  Sample_Columns <- which(G$sampleMeta$Condition %in% G$Conditions)
  rowMeans <- apply(hmData[,Sample_Columns],1,mean)
  rowSD <- apply(hmData[,Sample_Columns],1,sd)+0.01
  zData <- cap( t(t(hmData-rowMeans)/rowSD),-3,3)
  rm(rowMeans,rowSD)
  rownames(zData)<- DisplayName(rownames(zData))############
  
  ColumnLabels <- colnames(zData)
  for (j in 1:length(ColumnLabels)) 
    ColumnLabels[j] <- paste( G$sampleMeta$SHORTNAME[G$sampleMeta$Sample ==  ColumnLabels[j]],
                              G$sampleMeta$Condition[G$sampleMeta$Sample ==  ColumnLabels[j]])
  
  ColLabelColors <- rep(G$COLORS[2],ncol(fc));
  ColLabelColors[G$sampleMeta$Condition == G$Conditions[1]] <- G$COLORS[1];
  ColLabelColors[G$sampleMeta$Condition == G$Conditions[2]] <- G$COLORS[3];
  
  
  #primary, everyone, and large
  pdf(plotFile,width=max(c(3.5,ncol(fc)*0.30))+1,height=max(c(2,sum(DEG)*0.2))+2)
  heatmap.2(zData,  
            scale="none", trace="none", dendrogram="both", margins=c(10,10),
            cellnote=cellnote, notecol="black", notecex=0.75,labCol=ColumnLabels,
            ColSideColors=ColLabelColors, col=G$COLORFUNCTION)
  dev.off()
  
  plotFile=sprintf("%s/HM-.%s.%s.%d.pdf",G$Output_Folder, G$C2T[1],G$C2T[2],sum(DEG))
  #and a small one:
  pdf(plotFile,width=max(c(4,ncol(fc)*0.22))+1,height=max(c(2,sum(DEG)*0.1))+2)
  heatmap.2(zData,  labRow="", key=FALSE,  margins=c(10,10),
            scale="none", trace="none",dendrogram="none",labCol=ColumnLabels,
            ColSideColors=ColLabelColors, col=G$COLORFUNCTION)
  dev.off()
  
  COI <- (ColLabelColors != G$COLORS[2])
  
  plotFile <- sprintf("%s/HMS.%s.%s.%d.pdf",G$Output_Folder, G$C2T[1],G$C2T[2],sum(DEG))
  pdf(plotFile,width=max(c(4,sum(COI)*0.30))+1,height=max(c(2,sum(DEG)*0.2))+2)
  heatmap.2(zData[,COI],  
            scale="none", trace="none", dendrogram="both", margins=c(10,10),
            cellnote=cellnote[,COI], notecol="black", notecex=0.75,labCol=ColumnLabels[COI],
            ColSideColors=ColLabelColors[COI], col=G$COLORFUNCTION)
  dev.off()
  
  plotFile=sprintf("%s/HMS-.%s.%s.%d.pdf",G$Output_Folder, G$C2T[1],G$C2T[2],sum(DEG))
  pdf(plotFile,width=max(c(4,sum(COI)*0.22))+1,height=max(c(2,sum(DEG)*0.1))+2)
  heatmap.2(zData[,COI],  labRow="", key=FALSE,  margins=c(10,10),
            scale="none", trace="none",dendrogram="none",labCol=ColumnLabels[COI],
            ColSideColors=ColLabelColors[COI], col=G$COLORFUNCTION)
  dev.off()

}

###### borrowed code found online #################################################
#Description: Reverses the direction of a bidirectional mapping, removes an entries pointing to NULL
#Author: Matthew Young
#Date Modified: 13/12/2010
reverseMap=function(map){
  tmp=unlist(map,use.names=FALSE)
  names(tmp)=rep(names(map),times=as.numeric(summary(map)[,1]))
  return(split(names(tmp),as.vector(tmp)))
}
#########################################

# setup the two test conditions, 'the contrast' we're going to test.
GSEPD_ChangeConditions <- function(GSEPD, newConditions){
  newConditions = as.character(newConditions[1:2]) # cleanup
  if(length(newConditions)==2){
    samples_conds <-  as.character(GSEPD$sampleMeta$Condition[GSEPD$sampleMeta$Condition %in% newConditions])
    tconds=table(samples_conds)
    if(any(tconds)<1){#check that we're not missing any
      missingno <- names(tconds[tconds<1])[1]
      om <- sprintf("cannot set the comparison conditions to '%s' vs '%s' because sampleMeta$Condition has no samples of type '%s'",
                    newConditions[1],newConditions[2],missingno)
      stop(om)
    }
    conds=paste(samples_conds, tconds[samples_conds], sep=GSEPD$C2T_Delimiter)
    GSEPD$Conditions <- sort(newConditions)
    GSEPD$C2T<- sort(unique( as.character(factor(conds))  ))
    return(GSEPD)
  }else{
    stop("must specify two conditions")
  }
}


GSEPD_ChangeOutput <- function(GSEPD, newFolder){
  if(length(newFolder)==1){
    
    GSEPD$Output_Folder <- newFolder
    
    if(!(file.exists(GSEPD$Output_Folder)))
      dir.create(GSEPD$Output_Folder)
    GSEPD$Output_SCGO <- paste(GSEPD$Output_Folder,"/SCGO",sep="")
    
    if(!(file.exists(GSEPD$Output_SCGO)))
      dir.create(GSEPD$Output_SCGO)
    
    return(GSEPD)
  }else{
    stop("must specify one output folder name")
  }
}

GSEPD_PullDEG <- function(GSEPD, PTHRESH){
  INF<-DESEQ_RFile(GSEPD)
  if(file.exists(INF)){
    DE.data<-read.csv(INF,as.is=TRUE,header=TRUE)
    return( unique(subset(DE.data, DE.data$padj<=PTHRESH)$id ))
  }else{
    om<-sprintf("Failure accessing %s to get the gene list for you.", INF)
    stop(om)
  }
}

#a simple interface to DESeq, 
#assuming you have a finalCounts matrix with 'samples' columns
#part of the rgsepd-0.3.3 package KStamm June 2014

GSEPD_Process <- function(GSEPD){
  
  if(is.null(GSEPD$Conditions))
    stop("Must specify conditions to test with GSEPD_ChangeConditions before GSEPD_Process")
  
  #this is a fine time to clean up the ID converter
  #since you've provided all relevant transcript IDs.
  EnsureCleanIDs(rownames(GSEPD$finalCounts))
  
  GSEPD$Conditions <- sort(GSEPD$Conditions)
  sampleMeta <- GSEPD$sampleMeta
  conds <- GSEPD$Conditions
  
  #this would be a good place to make sure "conds" are in sampleMeta$Conditions
  if(!(all(conds %in% sampleMeta$Condition))) 
    stop("specified conditions not found in sample metadata table")
  
  samples <- sampleMeta$Sample[sampleMeta$Condition %in% conds]
  samples_conds <-  sampleMeta$Condition[sampleMeta$Condition %in% conds]
  
  #Count the subjects of each type and affix xN to their types.
  tconds=table(samples_conds)
  conds=paste(samples_conds,tconds[samples_conds],sep=GSEPD$C2T_Delimiter)
  conds <- factor( conds)
  C2T = sort(  unique(as.character(conds))  )  
  GSEPD$C2T<-C2T
  
  GSEPD <- GSEPD_CheckCounts(GSEPD)
  if(!file.exists(DESEQ_CountsFile(GSEPD))) {
    if(!GSEPD$QUIET)Message_Generate(DESEQ_CountsFile(GSEPD), TRUE)
    write.csv( GSEPD$normCounts, DESEQ_CountsFile(GSEPD))
  }else{
    #file already exists
    if(!GSEPD$QUIET)Message_Generate(DESEQ_CountsFile(GSEPD), FALSE)
  }
  
  if(!file.exists(GSEPD_HMA_File(GSEPD))){ #the final HMA is not done, make it from
    if(!file.exists(GSEPD_MFile(GSEPD))){ #if the M file is not done, make it
      if(!file.exists(GSEPD_GO2File(GSEPD))){ #if the GO2 file is not done, make it
        if(!file.exists(DESEQ_AFile(GSEPD))){ #if the A file is not done, make it
          if(!file.exists(DESEQ_RFile(GSEPD))){ #if the RES file is not done, make it
            ProcessDESEQ(GSEPD)
          }
          AnnotateTable(GSEPD)
          GSEPD_DEGHeatmap(GSEPD) ; #as soon as we made the .Annote file
        }
        suppressWarnings({ #dont worry about GOSeq's complaints. 
          AnnotateTable.GO(GSEPD)
        })
      }
      FileMerge(GSEPD)
    }
    
    tryCatch({ #sometimes the PCA fails...
      GSEPD_PCA_Plot(GSEPD) ## make another picture
      }, warning = function(w) {
        warning(w)
      }, error = function(e) {
        warning(e) #but it's no big deal if a picture isn't made.
      })
    
    GSEPD_ProjectionProcessor(GSEPD) #and do a lot of work.
  }
  MergeResultsTables(GSEPD)
  if(!GSEPD$QUIET) message("All Done!")
  #finally return
  GSEPD
}

MergeResultsTables <- function(G){
#finally, to match the resulting HMA we want to pick up exciting GO terms
  if(!G$QUIET)Message_Generate(GSEPD_HMACSV_File(G))
  #we'll produce the filtered file because .Alpha and .Beta already contain everything. 
  # don't really need extra filters for .Beta linearity, just making the shortlist final output
  GO<-read.csv(GSEPD_GOFile(G),as.is=TRUE,header=TRUE,row.names=1)
  SEG <- read.csv(GSEPD_Seg_File(G),as.is=TRUE,header=TRUE,row.names=1) #these row names are go terms
  
  Limit_GO  <- ifelse(G$LIMIT$HARD , G$LIMIT$GO_PVAL , max(c(median(GO$over_represented_pvalue) , G$LIMIT$GO_PVAL)) )
  Limit_Seg <- ifelse(G$LIMIT$HARD , G$LIMIT$Seg_P   , max(c(median(SEG$Segregation_PV) , G$LIMIT$Seg_P)))
  
  OM<-merge( subset(GO, GO$over_represented_pvalue <= Limit_GO),
             subset(SEG,SEG$Segregation_PV <= Limit_Seg), by.x="category", by.y="row.names")
  write.csv(OM,GSEPD_HMACSV_File(G));  
  
}

ProcessDESEQ <- function(G, 
                         deseq.contrast = "NULL",
                         deseq.lfcShrink = "normal"){
  if(missing(deseq.contrast))
    deseq.contrast=c("Condition",G$Conditions[1],G$Conditions[2])
  
  dds <- DESeq(GSEPD_Export_DESeq(G))
  res <- results(dds,
                 contrast=deseq.contrast,
                 lfcThreshold = as.numeric(G$LIMIT$LFC)[1])
  res <- lfcShrink(dds, 
                   type=deseq.lfcShrink,
                   contrast=deseq.contrast,
                   res = res)
  
#  message("trying to drop genes with zero baseMean");
#  res = subset(res,res$baseMean > 0.01)
#  message(paste("Filtered entries remaining: ",length(res$id)));
  
  #in DESeq1 we had columns  
  #  id  baseMean	baseMeanA	baseMeanB	foldChange	log2FoldChange	pval	padj
  #now we have columns 
  #   baseMean log2FoldChange      lfcSE       stat        pvalue          padj
  #so to mash it into the old format:
  res$pvalue[is.na(res$pvalue)] <- 1;#DESeq2 gave me NA's which broke later filters
  res$padj[is.na(res$padj)] <- 1; #so we'll mark them clearly not significant.
  res$id<-rownames(res); res$pval<-res$pvalue;res$foldChange<-2^res$log2FoldChange
  #it's a little more work to generate the C2T columns as baseMeanA/B.
  Columns.A <- which(colnames(G$finalCounts) %in% 
                       subset(G$sampleMeta, G$sampleMeta$Condition==G$Conditions[1])$Sample)
  Columns.B <- which(colnames(G$finalCounts) %in% 
                       subset(G$sampleMeta, G$sampleMeta$Condition==G$Conditions[2])$Sample)

  if(length(Columns.A)>1){
    res$baseMeanA <- apply( G$normCounts[,Columns.A],1,mean) #but normCounts are logspace, so this mean is biased low...
  }else{
    res$baseMeanA <- G$normCounts[,Columns.A] # mean of one element
  }
  if(length(Columns.B)>1){
    res$baseMeanB <- apply( G$normCounts[,Columns.B],1,mean)
  }else{
    res$baseMeanB <- G$normCounts[,Columns.B] # mean of one element
  }

  outfilename=paste(G$Output_Folder,"/DESEQ.Volcano.",G$C2T[1],".",G$C2T[2],".png",sep="")
  if(!G$QUIET)Message_Generate(outfilename)
  png(filename=outfilename); # volcano with 30K points was too slow as PDF
  plotDE( res )
  dev.off();
  
  if(!G$QUIET)Message_Generate(DESEQ_RFile(G))
  write.csv(res,file=DESEQ_RFile(G));
}

#run the above, iterated by possible pairings
GSEPD_ProcessAll <- function(G){
  X<-as.character(unique(G$sampleMeta$Condition))
  Xn<-length(X)
  message(sprintf("Preparing to run %d conditions as %d pairs",Xn,Xn*(Xn-1)/2))
  for(i in 1:(Xn-1))
    for(j in (i+1):Xn){
      G<-GSEPD_ChangeConditions(G,c(X[i],X[j]))
      G<-GSEPD_Process(G)
    }
  G
}

## V-Measure for external cluster validation
## a conditional entropy-based evaluation measure
#a harmonic mean of the entropic homogeneity and completeness
# Rosenberg & Hirschberg 2007, 

Homogeneity<-function(A){
  N <- sum(A)
  A<-A[,colSums(A)>0] #filter that C=0 column
  #print(A)
  HCK <- 0- sum(mapply(function(K)
    sum(mapply(function(C)
      ifelse(A[K,C]==0, 0, 
             (A[K,C]/N)*log(A[K,C]/sum(A[K,]),2) )
               ,1:ncol(A)))
                       ,1:nrow(A)))
  
  if(HCK==0) return(1);
  HC <- 0- sum(mapply(function(C){
    sum(A[,C])/N * log( sum(A[,C])/N ,2)
  },1:ncol(A)))
  
  return(1-HCK/HC)
}
Completeness <- function(A){
  N <- sum(A)
  A<-A[,colSums(A)>0] #filter that C=0 column
  HCK <- 0- sum(mapply(function(C)
    sum(mapply(function(K)
      ifelse(A[K,C]==0,0,
      (A[K,C]/N)*log(A[K,C]/sum(A[,C]),2) )
               ,1:nrow(A)))
                       ,1:ncol(A)))
  
  if(HCK==0) return(1);
  HK <- 0- sum(mapply(function(K){ sum(A[K,])/N * log( sum(A[K,])/N ,2)  },1:nrow(A)))
  
  return(1-HCK/HK)
}
VMeasure <- function(A, beta=1){
  H<-Homogeneity(A)
  C<-Completeness(A)
  V<-((1+beta)*H*C)/(beta*H + C)
  return( ifelse(is.nan(V),0,V)  )
}


#ROI is REFSEQ IDs, rows of the counts table.
#SOI is subject names; columns of the counts table.

Resampled_Significance.k<- function(GSEPD, ROI, SOI) {
  D<-GSEPD$normCounts[ROI,SOI]
  
  #scale induces a NaN if var==0
  #omit that: it wont help the clustering.
  rowVariation <- apply(D,1,var)
  #i expect we've induced a new crash potential, when <2 rows left
  keepRows <- (rowVariation>0.050)
  if(sum(keepRows) < 2){
    #but im not sure how to handle it. 
    #for now, call it a losing cluster with no segregation.
    return(list(Validity=0, PV=1))
  }
  D<-D[rowVariation>0.050,]

  D<-t(scale(t(  D  )))
  ob<-kmeans(t(D),centers=2, nstart=4)
  
  S1 <- names(ob$cluster[ob$cluster==1])
  S2 <- names(ob$cluster[ob$cluster==2])
  A <- Contingency_Matrix(GSEPD,S1,S2)
  TS <- VMeasure(A)
  PV <- 0
  #to compute random labels we'll repeatedly ask for the number of samples
  lSOI <- length(SOI) #so doing that once can be faster
  sample_rate <- length(S1)/lSOI
  Stepcount = pmax(round((1/GSEPD$Segregation_Precision)),2)
  if(TS < 1){
    TS_Range <- unlist(lapply(1:Stepcount, function(i){
      RB <- runif(lSOI) < sample_rate
      VMeasure(Contingency_Matrix(GSEPD,RB,!RB))
    }))
    PV<- mean( TS_Range >= TS )
    if(PV>0 && PV<0.50){ #some were better? let's go for more precision:
      TSR2 <- unlist(lapply(1:Stepcount, function(i){
        RB<-runif(lSOI) < sample_rate
        VMeasure(Contingency_Matrix(GSEPD,RB,!RB))
      }))
      TS_Range=c(TS_Range,TSR2)
      PV<- mean( TS_Range >= TS )
      #a third refinement for good luck
      if(PV>0.01 && PV<0.10){ # let's go for more precision:
        TSR2 <- unlist(lapply(1:(2*Stepcount), function(i){
          RB<-runif(lSOI) < sample_rate
          VMeasure(Contingency_Matrix(GSEPD,RB,!RB))
        }))
        TS_Range=c(TS_Range,TSR2)
        PV<- mean( TS_Range >= TS )
      }
    }
  }
  return(list(Validity=TS, PV=PV))
}

Contingency_Matrix <- function(GSEPD, G1,G2){
  #Group1 and Group2 are Sample names for Conditions1 and 2.
  Con<-GSEPD$sampleMeta$Condition
  names(Con)<-GSEPD$sampleMeta$Sample
  T1 <- c(sum(Con[G1] == GSEPD$Conditions[1]), sum(Con[G1] == GSEPD$Conditions[2]))
  T2 <- c(sum(Con[G2] == GSEPD$Conditions[1]), sum(Con[G2] == GSEPD$Conditions[2]))
  rbind(T1,T2)
}

GSEPD_PCA_Plot <- function(GSEPD, customColors=FALSE ){
  # customColors is a flag to use the sampleMeta$CustomColor rather than the Condition.
  
  sampleMeta<- GSEPD$sampleMeta
  Condition<- GSEPD$Conditions
  if(is.null(Condition)) 
    stop("Must specify conditions to test with GSEPD_ChangeConditions before GSEPD_PCA_Plot")
   #if only due to the CheckCounts below.
  
  COLORS=GSEPD$COLORS
  if(!(all(Condition %in% sampleMeta$Condition))) 
    stop("specified conditions to test not found in sample metadata table")
  
  GSEPD<-GSEPD_CheckCounts(GSEPD) #ensure #normCounts exists....
  fc <- GSEPD$normCounts
  dropRows <- apply(fc,1,mean) < 0 #normCounts are DESeq2 VST, nearly log2 space
  fc<-fc[!dropRows,]
  sfc<-t(scale(t( (fc))))
  dropRows <- apply(sfc,1,function(x){any(is.nan(x))})
  sfc=sfc[!dropRows,]
  
  if(nrow(sfc) <= ncol(sfc)){
    #not enough DEG to bother PCAing...
    warning("fewer expressed genes than subjects: won't PCA")
    return();
  }
  
  
  cols=rep(1,ncol(sfc))
  
  if(customColors){
    if("CustomColor" %in% colnames(sampleMeta)){
      cols=sampleMeta$CustomColor
    }else{
      # user asked for CustomColors to be used, but I don't have any available.
      message("User asked for customColors, but didn't specify the sampleMeta$CustomColor column. Using defaults instead.")
    }
  }
  
  if(all(cols==1)){# default behavior is to color dots like the Conditions
    cols[as.character(sampleMeta$Condition)==Condition[1]]=COLORS[1]
    cols[as.character(sampleMeta$Condition)==Condition[2]]=COLORS[3]
  }
  
  sms=colnames(sfc)

  pchs=rep(3,ncol(sfc));
  pchs[as.character(sampleMeta$Condition)==Condition[1]]=1
  pchs[as.character(sampleMeta$Condition)==Condition[2]]=2
  
  pc.md<-prcomp(sfc)
  
  lbs=unlist(lapply(1:ncol(sfc),function(i){sampleMeta$SHORTNAME[sampleMeta$Sample==colnames(sfc)[i]]}))
  dims=c("PC1","PC2")
  outfilename=sprintf("%s/GSEPD.PCA_AG.%s.%s.pdf",GSEPD$Output_Folder,GSEPD$C2T[1],GSEPD$C2T[2])
  Message_Generate(outfilename)
  pdf(outfilename,width=6,height=6)
    plot(pc.md$rotation[,dims], xlab="", ylab="", col=cols, pch=pchs)
    x=pc.md$rotation[,dims[1]]
    y=pc.md$rotation[,dims[2]]
    xo=rep(0,ncol(sfc)) ; yo=xo;
    text(x=x+xo,y=y-0.015+yo,labels=lbs, xpd=TRUE, cex=0.75)
    ANNOTE_GENES=min(c(5,nrow(sfc))) #the most important genes are 
    PC1= names(sort( abs(pc.md$x[,dims[1]]) ,
                     decreasing=TRUE )[1:ANNOTE_GENES])
    gns=DisplayName(PC1);
    mtext(side=1,text=gns,at=seq(min(x),max(x),length.out=ANNOTE_GENES),line=3)
    PC2= names(sort( abs(pc.md$x[,dims[2]]) ,
                     decreasing=TRUE )[1:ANNOTE_GENES])
    gns=DisplayName(PC2);
    mtext(side=2,text=gns,at=seq(min(y),max(y),length.out=ANNOTE_GENES),line=3) 
    if(customColors){
      # have to generate a smarter legend
      # but we have no idea what sort of symbols the user may supply.
      # no legend for now.
      }else{# default legend:
        legend(GSEPD$PCA_LEGEND,legend=c(Condition,"Other"), pch=c(1,2,3), col=c(COLORS[c(1,3)],1))   
    }
    title(main=paste("PCA over",nrow(sfc),"transcripts"))
  dev.off();
  
  if(file.exists(DESEQ_RFile(GSEPD))){
    DE.data<-read.csv(DESEQ_RFile(GSEPD),as.is=TRUE,header=TRUE)
    DE.data <- subset(DE.data, !(DE.data$id %in% GSEPD$EXCLUDES))
    keepRows <- c();
    if(GSEPD$LIMIT$HARD){
      keepRows=DE.data$id[ DE.data$padj <= GSEPD$LIMIT$PADJ &
                             abs(DE.data$log2FoldChange) >= GSEPD$LIMIT$LFC &
                             DE.data$baseMean >= GSEPD$LIMIT$baseMean ]
    }else{ #soft limits:
      TargetCount = (ncol(sfc)+1)
      if(sum(DE.data$padj<0.05) > TargetCount){
        keepRows=DE.data$id[DE.data$padj<0.05]
      }else if(sum(DE.data$pval<0.01) > TargetCount) {
        keepRows=DE.data$id[DE.data$pval<0.01]
      }else if(sum(DE.data$pval<0.05) > TargetCount){
        keepRows=DE.data$id[DE.data$pval<0.05]
      }else {
        pthresh=sort(DE.data$pval,decreasing=FALSE)[TargetCount]
        keepRows=DE.data$id[DE.data$pval<pthresh]
      }
    }
    keepRows=keepRows[keepRows%in%rownames(sfc)]
    sfc=sfc[keepRows,]
    
    if(nrow(sfc) < 3){
      #not enough DEG to bother PCAing...
      warning("less than three filtered genes: can't meaningfully PCA for DEG")
      return();
    }

    pc.md<-prcomp(sfc)
    outfilename=sprintf("%s/GSEPD.PCA_DEG.%s.%s.pdf",GSEPD$Output_Folder,GSEPD$C2T[1],GSEPD$C2T[2])
    Message_Generate(outfilename)
    pdf(outfilename,width=6,height=6)
      plot(pc.md$rotation[,dims], xlab="", ylab="", col=cols, pch=pchs)
      x=pc.md$rotation[,dims[1]]
      y=pc.md$rotation[,dims[2]]
      xo=rep(0,ncol(sfc)) ; yo=xo;
      text(x=x+xo,y=y-0.015+yo,labels=lbs, xpd=TRUE, cex=0.75)
      ANNOTE_GENES=min(c(5,nrow(sfc))) #the most important genes are 
      PC1= names(sort( abs(pc.md$x[,dims[1]]) ,
                       decreasing=TRUE )[1:ANNOTE_GENES])
      gns=DisplayName(PC1)
      mtext(side=1,text=gns,at=seq(min(x),max(x),length.out=ANNOTE_GENES),line=3)
      PC2= names(sort( abs(pc.md$x[,dims[2]]) ,
                       decreasing=TRUE )[1:ANNOTE_GENES])
      gns=DisplayName(PC2)
      mtext(side=2,text=gns,at=seq(min(y),max(y),length.out=ANNOTE_GENES),line=3) 
      if(customColors){
        # have to generate a smarter legend
        # but we have no idea what sort of symbols the user may supply.
        # no legend for now.
      }else{# default legend:
        legend(GSEPD$PCA_LEGEND,legend=c(Condition,"Other"), pch=c(1,2,3), col=c(COLORS[c(1,3)],1))   
      }
      title(main=paste("PCA over",nrow(sfc),"transcripts"))
    dev.off();
  }
}



GSEPD_PCA_Spec <- function(GSEPD, GOT, MDATA=NULL, customColors=FALSE){
  
  sampleMeta<- GSEPD$sampleMeta
  Condition<- GSEPD$Conditions
  COLORS=GSEPD$COLORS
  if(!(all(Condition %in% sampleMeta$Condition))) 
    stop("specified conditions not found in sample metadata table")
  
  ## pick up Mdata
  #pull up the merged doc and grab the minor GO term
  if(missing(MDATA) || is.null(MDATA)) {
   if(file.exists(GSEPD_MFile(GSEPD)))
      M.data <- read.csv(GSEPD_MFile(GSEPD), as.is=TRUE, header=TRUE,row.names=1) 
    else
      stop("Cannot PCA_Spec the given GO term because the .MERGE file is not found, be sure to run a full GSEPD_Process() first.")
  }
  else
    M.data <- MDATA
  
  #HGNC <- hash(M.data$REFSEQ, M.data$HGNC)
  HGNC <- as.character(M.data$HGNC)
  names(HGNC) <- as.character(M.data$REFSEQ)
  
  roi <- (M.data$category==GOT) #find the entry in Mdata
  GOName<-sprintf("%s %s",M.data$Term.x[roi][1], M.data$category[roi][1]); 
  #select GOI
  GOI = M.data$REFSEQ[roi];
  fc <- GSEPD$normCounts[GOI,]
  NS=ncol(GSEPD$normCounts)
  NG=length(GOI)
  
  
  cols=rep(1,NS)
  if(customColors){
    if("CustomColor" %in% colnames(sampleMeta)){
      cols=sampleMeta$CustomColor
    }else{
      # user asked for CustomColors to be used, but I don't have any available.
      message("User asked for customColors, but didn't specify the sampleMeta$CustomColor column. Using defaults instead.")
    }
  }
  if(all(cols==1)){# default behavior is to color dots like the Conditions
    cols[as.character(sampleMeta$Condition)==Condition[1]]=COLORS[1]
    cols[as.character(sampleMeta$Condition)==Condition[2]]=COLORS[3]
  }
  
  pchs=rep(3,NS);
  pchs[as.character(sampleMeta$Condition)==Condition[1]]=1
  pchs[as.character(sampleMeta$Condition)==Condition[2]]=2
  lbs=unlist(lapply(1:NS,function(i){
    sampleMeta$SHORTNAME[sampleMeta$Sample==colnames(fc)[i]]}))
  
  if(NG<1){
    stop(sprintf("Cannot GSEPD_PCA_Spec ... no genes found in %s for category %s",GSEPD_MFile(GSEPD),GOT))
  }else if(NG<2){ ## == 1 ... histogram??
    hist(fc, main=sprintf("Normalized Counts at %s",DisplayName(GOI)), xlab="Reads")
    points(x=fc, y=runif(length(fc))*5+2, cex=2,pch=pchs,col=cols)    
  }else if(NG<3){ ## == 2 ... regular scatter plot
    sfc=fc
    gns=HGNC[rownames(sfc)]
    plot(x=sfc[1,], y=sfc[2,],
         xlab=sprintf("%s Normalized Counts",gns[1]),
         ylab=sprintf("%s Normalized Counts",gns[2]),
         main=sprintf("Scatter for %s",GOName),
         pch=pchs, col=cols )    
    xo=rep(0,NS) ; yo=xo;
    text(x=sfc[1,]+xo,y=sfc[2,]-0.015+yo,labels=lbs, xpd=TRUE, cex=0.75)
  }else { ## prcomp when >2 genes
    sfc=t(scale(t(fc)))
    pc.md<-prcomp(sfc)
    dims=c("PC1","PC2")
    plot(pc.md$rotation[,dims], xlab="", ylab="", col=cols, pch=pchs, main=sprintf("PCA for %s",GOName))
    x=pc.md$rotation[,dims[1]]
    y=pc.md$rotation[,dims[2]]
    xo=rep(0,NS) ; yo=xo;
    text(x=x+xo,y=y-0.015+yo,labels=lbs, xpd=TRUE, cex=0.75)
    ANNOTE_GENES=min(c(5,nrow(sfc))) #the most important genes are 
    PC1= names(sort( abs(pc.md$x[,dims[1]]) ,
                     decreasing=TRUE )[1:ANNOTE_GENES])
    gns=as.character(HGNC[PC1])
    mtext(side=1,text=gns,at=seq(min(x),max(x),length.out=ANNOTE_GENES),line=3)
    PC2= names(sort( abs(pc.md$x[,dims[2]]) ,
                     decreasing=TRUE )[1:ANNOTE_GENES])
    gns=as.character(HGNC[PC2])
    mtext(side=2,text=gns,at=seq(min(y),max(y),length.out=ANNOTE_GENES),line=3) 
  }
  if(customColors){
    # have to generate a smarter legend
    # but we have no idea what sort of symbols the user may supply.
    # no legend for now.
  }else{# default legend:
    legend(GSEPD$PCA_LEGEND,legend=c(Condition,"Other"), pch=c(1,2,3), col=c(COLORS[c(1,3)],1))   
  }
  
}

# demonstration using existing dataset.

if(FALSE){
  BiocManager::install("HSMMSingleCell")
  
  ??HSMMSingleCell
  
  ?HSMMSingleCell
  
  install.packages("monocle")
  BiocManager::install("monocle")
}
library(HSMMSingleCell)

library(monocle)

library(rgsepd)
library(AnnotationDbi)
library(org.Hs.eg.db)

x <- load_HSMM()
#rownames(x@assayData$exprs )
ensg = rownames(x@assayData$exprs )

x@phenoData@data$Media
table(x@phenoData@data$State, x@phenoData@data$Hours)

fixed_names = sapply(strsplit(ensg, ".", fixed=T), function(x) x[1])
lookedup <- select(org.Hs.eg.db,keytype="ENSEMBL",
                   keys=fixed_names, multiVals="first",
                   columns=c('REFSEQ'))

lookedup <- subset(lookedup, !is.na(REFSEQ))
lookedup <- subset(lookedup, !duplicated(ENSEMBL))
lookedup <- subset(lookedup, !duplicated(REFSEQ))

# THESE ARE FPKM from cufflinks 
fc = x@assayData$exprs
rownames(fc) <- fixed_names
fc <- fc[lookedup$ENSEMBL,]
#nrow(fc)
#fc[10:11,1:3]
#x@assayData$exprs[sapply(c("ENSG00000001167","ENSG00000001460"), function(i) grep(i, ensg) ),1:3]
rownames(fc) <- lookedup$REFSEQ
ncol(fc)
# 271 samples !


x@phenoData$Well

SM = data.frame(Sample = colnames(fc),
                Condition = sprintf("H%02d",as.numeric(as.character(x@phenoData$Hours))),
                SHORTNAME = paste( sapply(strsplit(colnames(fc), "_", fixed=T), function(x) x[1]),
                sapply(strsplit(colnames(fc), "_", fixed=T), function(x) x[3]), sep="_" ) ) 

head(SM)

# want to reduce the number of samples to some similar ones.
# my rgsepd system is failing when the groups are so diverse
# these timepoints are super varied
# some of these samples are outliers - different paths vs the group.


# select the middle-most??
pick_samples <- function(CONDITION){
  sC = t(log(fc[, SM$Condition==CONDITION] +0.1) )
  pox = princomp(t(sC))
  midsection <- function(x, thresh=0.2){
    j=which( x > quantile(x,thresh) & x < quantile(x,1-thresh))
    j
  }
  i=intersect(midsection(pox$loadings[,'Comp.1']),
              midsection(pox$loadings[,'Comp.2']))
  normal_samples = rownames(sC)[i]
  which(SM$Sample %in% normal_samples)
}


CUTDOWN=FALSE
if(CUTDOWN){
# then we'll subset for speed please.
#i = unlist(lapply( unique(SM$Condition), pick_samples))
i=which(SM$Sample %in% rownames(x@phenoData@data)[x@phenoData@data$State==2])
fc = fc[,i]
SM = SM[i,]
}

G <- GSEPD_INIT(Output_Folder="OUT",
                finalCounts=round(fc*1000),
                sampleMeta=SM,
                COLORS=c("green","black","red"))

#loosen statistics to ensure this example gets some gene sets 'enriched'
#G$LIMIT$LFC=0.1;
#G$LIMIT$HARD=FALSE
#G$LIMIT$GO_PVAL <- 0.5
#G$LIMIT$PADJ <- 0.1
#G$LIMIT$Seg_P <- 0.1
#G$LIMIT$baseMean <- 2

G$LIMIT$goseq_padj_method <- "none"

G <- GSEPD_ChangeConditions( G, c("H24","H48")) #set testing groups first!    
G <- GSEPD_Process( G ) #have to have processed results to plot them

## ----setup_latex, include=FALSE, cache=FALSE, echo=FALSE----------------------
Sys.setenv(TEXINPUTS=getwd(),
           BIBINPUTS=getwd(),
           BSTINPUTS=getwd())
library(xtable)

## ----dataload-----------------------------------------------------------------
library(rgsepd)
set.seed(1000) #fixed randomness
data("IlluminaBodymap" , package="rgsepd")
data("IlluminaBodymapMeta" , package="rgsepd")

## ----MyT1CodeBlock, echo = FALSE, results = 'hide'----------------------------
T1 <- head(IlluminaBodymap,n=10L)[,c(1,2,3,4,5,9,13)]
T2 <- head(IlluminaBodymapMeta)

## ----MyLaTeXT1Caption, echo = FALSE, results = 'asis'-------------------------
xT<-xtable(T1, caption ="First few rows of the included IlluminaBodymap dataset. See \\texttt{?IlluminaBodymap} for more details.", label = 'MyT1')
print.xtable(xT, scalebox=0.75)
xtable(T2, caption ="First few rows of the included IlluminaBodymapMeta dataset. See \\texttt{?IlluminaBodymapMeta} for more details. These are easy to build with a spreadsheet, saved to csv and R's builtin \\texttt{?read.csv}", label = 'MyT2')

## ----setup--------------------------------------------------------------------
isoform_ids <- Name_to_RefSeq(c("GAPDH","HIF1A","EGFR","MYH7","CD33","BRCA2"))
rows_of_interest <- unique( c( isoform_ids ,
                    sample(rownames(IlluminaBodymap),
                    size=5000,replace=FALSE)))
G <- GSEPD_INIT(Output_Folder="OUT",
          finalCounts=round(IlluminaBodymap[rows_of_interest , ]),
          sampleMeta=IlluminaBodymapMeta,
            COLORS=c(blue="#4DA3FF",black="#000000",gold="#FFFF4D"))
G <- GSEPD_ChangeConditions( G, c("A","B"))

## ----ParameterChanging, cache=FALSE-------------------------------------------
  G$MAX_Genes_for_Heatmap <- 30
  G$MAX_GOs_for_Heatmap <- 25
  G$MaxGenesInSet <- 12
  G$LIMIT$LFC <- log( 2.50 , 2 )
  G$LIMIT$HARD <- FALSE

## ----GSEPD_Process, cache=FALSE-----------------------------------------------
  G <- GSEPD_Process( G )

## ----GSEPD_Heatmap_-_PCA------------------------------------------------------
  print(isoform_ids)
  GSEPD_Heatmap(G,isoform_ids)
  GSEPD_PCA_Plot(G)

## ----MyT3---------------------------------------------------------------------
Annotated_Filtered <- read.csv("OUT/DESEQ.RES.Ax4.Bx8.Annote_Filter.csv",
                      header=TRUE,as.is=TRUE)

## ----MyLaTeXT3Caption, echo = FALSE, results = 'asis'-------------------------
xT<-xtable(head(Annotated_Filtered, n=10L),
           caption ="First few rows of OUT/DESEQ.RES.Ax4.Bx8.Annote\\_Filter.csv which contains the DESeq results, cropped for significant results, and annotated with gene names (the HGNC Symbol).", label = 'Table_Annote')
print(xT, scalebox=0.70, include.rownames=FALSE)

## ----MyLaTeXT5Caption, echo = FALSE, results = 'asis'-------------------------
Merge_File <- read.csv("OUT/GSEPD.RES.Ax4.Bx8.MERGE.csv",
                      header=TRUE,as.is=TRUE, nrows=20)
xT<-xtable(head(Merge_File, n=15L),
           caption ="First few rows of OUT/GSEPD.RES.Ax4.Bx8.MERGE.csv showing enriched GO Terms, and each terms' underlying gene expression averages per group. This data is central to the rgsepd package, defining the group centroids per GO-Term. It consists of the cross-product of the GO enrichment statistics and the DESeq differential expression and summarization. ", label = 'MyT5')
print(xT, scalebox=0.50, include.rownames=FALSE)

## ----AlphaBetaTables, echo = FALSE, results = 'asis'--------------------------
Alpha_File <- read.csv("OUT/GSEPD.Alpha.Ax4.Bx8.csv",
                      header=TRUE,as.is=TRUE, nrows=20, row.names=1)
xT<-xtable(head(Alpha_File, n=10L)[,c(1,2,3,4,5,9,13)],
           caption ="First ten rows of OUT/GSEPD.Alpha.Ax4.Bx8.csv showing the group projection scores for each sample, these directly correspond to the colors in the HMA file. Where the HMA displays only significant sets, the Alpha table continues for all tested GO Terms. Both the Alpha table and Beta table are summarized in Figure \\ref{fig:HMA}.", label = 'TableAlpha')
print(xT, scalebox=0.80, include.rownames=TRUE)
Beta_File <- read.csv("OUT/GSEPD.Beta.Ax4.Bx8.csv",
                      header=TRUE,as.is=TRUE, nrows=20, row.names=1)
xT<-xtable(head(Beta_File, n=10L)[,c(1,2,3,4,5,9,13)],
           caption ="First ten rows of OUT/GSEPD.Beta.Ax4.Bx8.csv showing the linear divergence (distance to axis) for each sample, high values here would be annotated with white dots on the HMA file to indicate that a sample is not falling on the axis. Non-tested samples are expected to frequently have high values here, the C group was not part of the A vs B comparison.  Where the HMA displays only significant sets, the Beta table continues for all tested GO Terms. Both the Alpha table and Beta table are summarized in Figure \\ref{fig:HMA}.", label = 'TableBeta')
print(xT, scalebox=0.80, include.rownames=TRUE)
Gamma1_File <- read.csv("OUT/GSEPD.HMG1.Ax4.Bx8.csv",
                      header=TRUE,as.is=TRUE, nrows=20, row.names=1)
xT<-xtable(head(Gamma1_File, n=10L)[,c(1,2,3,4,5,9,13)],
           caption ="First ten rows of OUT/GSEPD.HMG1.Ax4.Bx8.csv showing the z-scaled distance to the Group1 centroid for each sample, these directly correspond to the colors in the HMG file. Where the HMG displays only significant sets, the Gamma table continues for all tested GO Terms. Both the Gamma1 and Gamma2 tables are summarized in Figure \\ref{fig:HMG}. Distance is normalized to dimensionality by scaling between the centroids. Thus a score of 0 means the sample resides on the centroid, and a score of 1 means it resides on the opposite class centroid, or equidistant.", label = 'TableGamma1')
print(xT, scalebox=0.80, include.rownames=TRUE)
Gamma2_File <- read.csv("OUT/GSEPD.HMG2.Ax4.Bx8.csv",
                      header=TRUE,as.is=TRUE, nrows=20, row.names=1)
xT<-xtable(head(Gamma2_File, n=10L)[,c(1,2,3,4,5,9,13)],
           caption ="First ten rows of OUT/GSEPD.HMG2.Ax4.Bx8.csv showing the z-scaled distance to the Group2 centroid for each sample, these directly correspond to the colors in the HMG file. Where the HMG displays only significant sets, the Gamma table continues for all tested GO Terms. Both the Gamma1 and Gamma2 tables are summarized in Figure \\ref{fig:HMG}. Distance is normalized to dimensionality by scaling between the centroids. Thus a score of 0 means the sample resides on the centroid, and a score of 1 means it resides on the opposite class centroid, or equidistant.", label = 'TableGamma2')
print(xT, scalebox=0.80, include.rownames=TRUE)

## ----FindFiles, echo = FALSE, results = 'asis'--------------------------------
HM_File <- list.files("OUT",pattern="HM.A")
PScatter_File <- list.files("OUT//SCGO",pattern="Scatter.Ax")[1]
PGSEPD_File <- list.files("OUT//SCGO",pattern="GSEPD.Ax")[1]
PPairs_File <- list.files("OUT//SCGO",pattern="Pairs.Ax")[1]
#trim the .PDF
HM_File <- substring(HM_File,0,nchar(HM_File)-4)
PScatter_File <- substring(PScatter_File,0,nchar(PScatter_File)-4)
PGSEPD_File <- substring(PGSEPD_File,0,nchar(PGSEPD_File)-4)
PPairs_File <- substring(PPairs_File,0,nchar(PPairs_File)-4)


## ----sessionInfo--------------------------------------------------------------
  sessionInfo()

#plot selected values of your dataset
# rgsepd-0.3.3 June 2014 KStamm
#make sure your G object is finished 
#and that your specified genes are rownames of finalCounts
#version 0.99.7 adding some error handling November2014-KStamm


GSEPD_Heatmap <- function(G,genes,cap_range=3,cellnote="log10"){
  
  G<-GSEPD_CheckCounts(G) #have to have finished GSEPD_Process() before we can use it
  
  KeeperRows <- genes %in% rownames(G$normCounts)
  if(any(KeeperRows==FALSE))
    message(sprintf("Warning: %d gene ids are not found in count data",sum(KeeperRows==FALSE)))
  genes<-genes[KeeperRows];rm(KeeperRows)
  
  fc<-G$normCounts[genes,G$sampleMeta$Sample] #doublecheck the column order
  fc=fc[genes,] #subset rows
  hmData <- fc
  if(cellnote=="log10")
   cellnote=signif(fc,digits=2)
  
  Sample_Columns <- which(G$sampleMeta$Condition %in% G$Conditions)
  rowMeans <- apply(hmData[,Sample_Columns],1,mean)
  rowSD <- apply(hmData[,Sample_Columns],1,sd)+0.01
  zData <- cap( t(t(hmData-rowMeans)/rowSD),0-cap_range,cap_range)
  rownames(zData)<- mapply( function(x){
    j<-DisplayName(x); if(is.na(j) || nchar(j)<2) j<-x; j}, rownames(zData))
  
  ColumnLabels <- colnames(zData)
  for (j in 1:length(ColumnLabels)) 
    ColumnLabels[j] <- paste( G$sampleMeta$SHORTNAME[G$sampleMeta$Sample ==  ColumnLabels[j]],
                              G$sampleMeta$Condition[G$sampleMeta$Sample ==  ColumnLabels[j]])
  
  ColLabelColors <- rep(G$COLORS[2],ncol(fc));#defaults to mid
  ColLabelColors[G$sampleMeta$Condition == G$Conditions[1]] <- G$COLORS[1];
  ColLabelColors[G$sampleMeta$Condition == G$Conditions[2]] <- G$COLORS[3];
  heatmap.2(zData,  
            scale="none", trace="none", dendrogram="both", margins=c(10,10),
            cellnote=cellnote, notecol="black", notecex=0.75,labCol=ColumnLabels,
            ColSideColors=ColLabelColors, col=G$COLORFUNCTION)  
}

#later when I want 'global' variables in the rgsepd code, theyll be stored under pkg_globals
pkg_globals <- new.env();


# the hash table package is going away in 2022 and we need to replace its functionality
hash <- function(keys, values){
  ht1 <- new.env(hash=TRUE)
  stopifnot(length(keys) == length(values))
  for(j in 1:length(keys)){
    ht1[[keys[j]]] <- values[j]
  }
  ht1
}


.onAttach <- function(libname, pkgname) {
  packageStartupMessage(sprintf("Loading R/GSEPD %s",packageDescription("rgsepd")$Version))
  packageStartupMessage("Building human gene name caches")
  
  #found the syntax for some kind of local/global variables here
  # http://stackoverflow.com/questions/12598242/global-variables-in-packages-in-r
  #assign("pkg_globals", new.env(), envir=parent.env(environment()))


  
  RefSeqs <- grep("^N[MR]_",
                  AnnotationDbi::keys(org.Hs.eg.db,keytype="REFSEQ"),
                  value=TRUE)
  lookedup <- select(org.Hs.eg.db,keytype="REFSEQ",
                     keys=RefSeqs, multiVals="first",
                     columns=c('SYMBOL','ENTREZID'))
  assign("R2H", hash(RefSeqs,lookedup$SYMBOL), pkg_globals)
  assign("R2E", hash(RefSeqs,lookedup$ENTREZID), pkg_globals)
  assign("H2R", hash(lookedup$SYMBOL,RefSeqs), pkg_globals)
  Egs <- AnnotationDbi::keys(org.Hs.eg.db,keytype="ENTREZID")
  lookedup <- select(org.Hs.eg.db,keytype="ENTREZID",
                     keys=Egs, multiVals="first",
                     columns=c('SYMBOL'))
  assign("H2E", hash(lookedup$SYMBOL,Egs), pkg_globals)
  assign("E2H", hash(Egs,lookedup$SYMBOL), pkg_globals)
         
}



## function definitions for GSEPD
## will run DESEQ and will run GOSeq
##then merge results, and process into GeneSetEnrichmentProfileDisplay

DESEQ_RFile <- function(G) 
  paste(G$Output_Folder,"/DESEQ.RES.",G$C2T[1],".",G$C2T[2],".csv",sep="")
DESEQ_AFile <- function(G) 
  paste(G$Output_Folder,"/DESEQ.RES.",G$C2T[1],".",G$C2T[2],".Annote.csv",sep="")
DESEQ_AFFile <- function(G) 
  paste(G$Output_Folder,"/DESEQ.RES.",G$C2T[1],".",G$C2T[2],".Annote_Filter.csv",sep="")
GSEPD_GOFile <- function(G) 
  paste(G$Output_Folder,"/GOSEQ.RES.",G$C2T[1],".",G$C2T[2],".GO.csv",sep="")
GSEPD_GOUpFile <- function(G) 
  paste(G$Output_Folder,"/GOSEQ.RES.",G$C2T[1],".",G$C2T[2],".GO-UP.csv",sep="")
GSEPD_GODownFile <- function(G) 
  paste(G$Output_Folder,"/GOSEQ.RES.",G$C2T[1],".",G$C2T[2],".GO-DOWN.csv",sep="")
GSEPD_GO2File <- function(G) 
  paste(G$Output_Folder,"/GSEPD.RES." , G$C2T[1],".",G$C2T[2],".GO2.csv",sep="")
GSEPD_MFile <- function(G) 
  paste(G$Output_Folder,"/GSEPD.RES." , G$C2T[1],".",G$C2T[2],".MERGE.csv",sep="")
GSEPD_HMA_File <- function(G) 
  paste(G$Output_Folder,"/GSEPD.HMA." , G$C2T[1],".",G$C2T[2],".pdf",sep="")
DESEQ_CountsFile <- function(G) 
  paste(G$Output_Folder,"/DESEQ.counts." , G$C2T[1],".",G$C2T[2],".csv",sep="")
GSEPD_Seg_File <- function(G) 
  paste(G$Output_Folder,"/GSEPD.Segregation_P." , G$C2T[1],".",G$C2T[2],".csv",sep="")
GSEPD_HMACSV_File <- function(G) 
  paste(G$Output_Folder,"/GSEPD.HMA." , G$C2T[1],".",G$C2T[2],".csv",sep="")
#new for 2016, let's calculate the distance to each centroid. 
GSEPD_HMG_File <- function(G) 
  paste(G$Output_Folder,"/GSEPD.HMG." , G$C2T[1],".",G$C2T[2],".pdf",sep="")
GSEPD_HMG1CSV_File <- function(G) 
  paste(G$Output_Folder,"/GSEPD.HMG1." , G$C2T[1],".",G$C2T[2],".csv",sep="")
GSEPD_HMG2CSV_File <- function(G) 
  paste(G$Output_Folder,"/GSEPD.HMG2." , G$C2T[1],".",G$C2T[2],".csv",sep="")


FileMerge<-function(GSEPD){
  
  if(!GSEPD$QUIET)Message_Generate(GSEPD_MFile(GSEPD))
  
  data.GO <- read.csv(GSEPD_GOFile(GSEPD),as.is=TRUE,header=TRUE)
  sGO1<-subset(data.GO[,c("category","over_represented_padj","Term")] , 
                   data.GO$over_represented_padj < (GSEPD$LIMIT$GO_PVAL * 1.25));
  sGO1$GOSEQ_DEG_Type <- rep("Mix", nrow(sGO1)) ; rm(data.GO)
  data.GO <- read.csv(GSEPD_GOUpFile(GSEPD),as.is=TRUE,header=TRUE)
  sGO2<-subset(data.GO[,c("category","over_represented_padj","Term")] , 
               data.GO$over_represented_padj < (GSEPD$LIMIT$GO_PVAL * 1.25));
  sGO2$GOSEQ_DEG_Type <- rep("Up", nrow(sGO2)) ; rm(data.GO)
  data.GO <- read.csv(GSEPD_GODownFile(GSEPD),as.is=TRUE,header=TRUE)
  sGO3<-subset(data.GO[,c("category","over_represented_padj","Term")] , 
               data.GO$over_represented_padj < (GSEPD$LIMIT$GO_PVAL * 1.25));
  sGO3$GOSEQ_DEG_Type <- rep("Down", nrow(sGO3)) ; rm(data.GO)
  
  sdata.GO <- rbind(sGO3,sGO2,sGO1) ; rm(sGO1,sGO2,sGO3)
  sdata.GO <- subset(sdata.GO, !duplicated(sdata.GO$category)) 
  
  data.GO2 <- read.csv(GSEPD_GO2File(GSEPD),as.is=TRUE,header=TRUE)
  
  tcats <- table(data.GO2$category)
  cats<-unique(data.GO2$category)
  cats=setdiff(cats,names(tcats)[tcats<GSEPD$MinGenesInSet | tcats>GSEPD$MaxGenesInSet])
  cats <- unique(c(cats,GSEPD$Force_GO_Include))

  mdata<-merge(sdata.GO, data.GO2, by.x="category",by.y="category")
  mdata<-subset(mdata, mdata$category %in% cats,
                select=c("category", "over_represented_padj.x","Term.x","GOSEQ_DEG_Type","HGNC", "LOG2.X.Y.","REFSEQ",
                         GSEPD$C2T[1],GSEPD$C2T[2], "PVAL","PADJ") )
  write.csv(mdata,GSEPD_MFile(GSEPD))
}


Message_Generate <- function(filename,overwrite=TRUE){
  if(file.exists(filename)){
    if(overwrite)
      message(sprintf("Generating %s, overwriting previous existing version.",filename))
    else
      message(sprintf("Would generate %s, but one is already present.",filename))
  }else{
    message(sprintf("Generating %s",filename))
  }
}

#Restrict elements of x to be between two numbers. 
cap<-function(x,L,H){x[x>H]=H;x[x<L]=L;x}

#Volcano Plot:
plotDE <- function( res ) {
  plot( 
    cap(res$log2FoldChange,-7,7), 
    0-log(res$pval,base=10), 
    pch=20, cex=.33, 
    col = ifelse( res$padj < .10, "red", "black" ),
    main=sprintf("Volcano for %d Genes",nrow(res)),
    xlab="Log2 FoldChange",
    ylab="Log10 p-value",
    sub="red points are significant with FDR < 10%")
}


#res is the table prepopulated with $id and other fields NA
LocalDB_Lookup <- function(res) 
  merge(res , build_Annotation_Matrix(res$id),
        by.x="id", by.y="REFSEQ", all.x=TRUE)


biomaRt_Lookup <- function(res) {  
  message("Converting identifiers with biomart");
  #now subset the table to those we didn't know yet.
  gns=unique( subset(res,is.na(res$ENTREZ))$id)
  #listMarts(host="www.ensembl.org")
  ensembl = useMart("ENSEMBL_MART_ENSEMBL", host="https://www.ensembl.org")
  ensembl = useDataset("hsapiens_gene_ensembl",mart=ensembl)
  attrs=listAttributes(ensembl)
  aa=c("refseq_mrna" , "chromosome_name" , "start_position" ,  "end_position" ,
       "entrezgene_id" ,      "hgnc_symbol",      "description" );
  
  #well of those that start with NM we want to query refseq_mrna
  #and for those that start withj NR we want to query refseq_ncrna
  gnsNM=gns[grep("NM_",gns)]
  if(length(gnsNM)>0){
    message(paste("Querying for",length(aa),"attributes from biomaRt on",length(gnsNM)," NM numbers"));
    bmt_NM=getBM(attributes = aa, filters = "refseq_mrna",values=gns[grep("NM_",gns)], mart = ensembl)
    message(paste("We got back",length(bmt_NM$refseq_mrna),"entries, which will be added to the local database."));
    if(nrow(bmt_NM)>0) {
    for(i in 1:length(bmt_NM$refseq_mrna)){
      rightrow=which(res$id==bmt_NM$refseq_mrna[i])[1];
      res$ENTREZ[rightrow] <- as.character(bmt_NM$entrezgene_id[i])
      res$HGNC[rightrow] <- as.character(bmt_NM$hgnc_symbol[i])
      res$LOCUS[rightrow] <- paste(bmt_NM$chromosome_name[i], ":",bmt_NM$start_position[i],"-",bmt_NM$end_position[i],sep="");
      res$DESC[rightrow] <- bmt_NM$description[i]
    } }
  }
  gnsNR=gns[grep("NR_",gns)]
  if(length(gnsNR)>0){
    message(paste("Querying for",length(aa),"attributes from biomaRt on",length(gnsNR)," NR numbers"));
    aa[1]="refseq_ncrna";
    bmt_NR=getBM(attributes = aa, filters = "refseq_ncrna",values=gns[grep("NR_",gns)], mart = ensembl)
    message(paste("We got back",length(bmt_NR$refseq_ncrna),"entries, which will be added to the local database."));
    if(nrow(bmt_NR)>0) {
    for(i in 1:length(bmt_NR$refseq_ncrna)){
      rightrow=which(res$id==bmt_NR$refseq_ncrna[i])[1];
      res$ENTREZ[rightrow] <- as.character(bmt_NR$entrezgene[i])
      res$HGNC[rightrow] <- as.character(bmt_NR$hgnc_symbol[i])
      res$LOCUS[rightrow] <- paste(bmt_NR$chromosome_name[i], ":",bmt_NR$start_position[i],"-",bmt_NR$end_position[i],sep="");
      res$DESC[rightrow] <- bmt_NR$description[i]
    } }
  }
  res
}



AnnotateTable <- function(G){
  C2T<-G$C2T
  infile=DESEQ_RFile(G)
  outfile=DESEQ_AFile(G)
  
  res=read.csv(infile,header=TRUE,as.is=TRUE)
  #res has got columns like
  #id	baseMean	baseMeanA	baseMeanB	foldChange	log2FoldChange	pval	padj
  # print("dumping rows with PADJ>0.90")
  # res=subset(res,padj <= 0.90)
  message("dropping rows with raw PVAL>0.990 OR baseMean < 1 OR on excludes list")
  res=subset(res,res$pval <= 0.990 & res$baseMean >= 1 & !(res$id %in% G$EXCLUDES))
  res$id = sub(" +$", "", res$id)
  message(paste("deseq txid rows remaining:",length(res$id)));
  if(length(unique(res$id)) < 1){
    warning("AnnotateTable : no rows significant enough to annotate.  Quitting table re-gen.");
    return();
  }
  
  message("Converting identifiers with local DB");
  res<-LocalDB_Lookup(res);
  #and the rest  #fix strings?
  res$ENTREZ <- as.character(res$ENTREZ)
  res$HGNC <- as.character(res$HGNC)
  
  # in 2022 Ensembl is giving warning messages about https
  # and https is giving error messages on ubuntu or cluster environments
  # we can omit the biomart calls and get our results more reliably. 
  if(FALSE){
   res = tryCatch({
     biomaRt_Lookup(res)
   }, warning = function(w) {
     warning(w)
     res
   }, error = function(e) {
     warning(e) #if bioMart is down, just keep moving.
     res
   })
  }
   
  res<-subset(res,select=c("id","baseMean","baseMeanA","baseMeanB","foldChange","log2FoldChange","lfcSE","pval","padj","HGNC","ENTREZ"))
  columns = c("REFSEQ","baseMean",C2T[1],C2T[2],"(X/Y)","LOG2(X/Y)","lfcSE","PVAL","PADJ","HGNC","ENTREZ");
  if(!G$QUIET)Message_Generate(outfile)
  write.table(res,file=outfile,row.names=FALSE,sep=",",col.names=columns);
  ## and a post-filter for shortlisting
  write.table(subset(res, res$padj <= G$LIMIT$PADJ &
                          abs(res$log2FoldChange) >= G$LIMIT$LFC &
                          res$baseMean >= G$LIMIT$baseMean )
              ,file=DESEQ_AFFile(G),row.names=FALSE,sep=",",col.names=columns);
  
}

AnnotateTable.GO <- function(G){
  C2T<-G$C2T
  infile=DESEQ_AFile(G)
  outfile=GSEPD_GOFile(G)
  outfile2=GSEPD_GO2File(G)
  plotFile=paste(G$Output_Folder,"/GOSEQ.PWF.",C2T[1],".",C2T[2],".pdf",sep="")
  
  data=read.csv(infile,as.is=TRUE,header=TRUE)
  data=subset(data,!duplicated(data$ENTREZ))
  sdata=subset(data,data$ENTREZ != "NA")
  
  #default hard filtering:
  DEG=ifelse(  sdata$PADJ < G$LIMIT$PADJ  &
                sdata$baseMean >= G$LIMIT$baseMean &
                abs(sdata$LOG2.X.Y.) >= G$LIMIT$LFC,
               1,0)
  
  #but if we're not set to HARD mode, and we got only a handful of genes:
  if( !(G$LIMIT$HARD) && sum(DEG)<(0.075*length(DEG))){
    ToLevel = round((0.075*nrow(sdata)))
    PThresh = sort(sdata$PVAL,decreasing=FALSE)[ToLevel]
    DEG = ifelse(sdata$PVAL < PThresh , 1,0)
    message( sprintf(
"Not many genes found differentially expressed, (re)moving the filters to raw p=%g so we can use %d genes with GOSEQ.",
                    PThresh,sum(DEG)))
  }
  if(sum(DEG)<2){
    stop("I can't do pathways or GO terms when so few genes pass significance. Try changing your G$LIMIT parameters.")
  }
  
  DEG.up = ifelse(DEG & (sdata$LOG2.X.Y. > 0) , 1,0)
  DEG.dn = ifelse(DEG & (sdata$LOG2.X.Y. < 0) , 1,0)
  
  names(DEG) <- sdata$ENTREZ;
  names(DEG.up) <- sdata$ENTREZ;
  names(DEG.dn) <- sdata$ENTREZ;
  
  pdf(plotFile)
  pwf <- nullp(DEG, G$GOSEQ$genome, G$GOSEQ$system)
  #rownames(pwf)<-sdata$REFSEQ # we're calling goseq() with gene system 'refGene'
  #error. 
  GO.wall <- goseq(pwf, G$GOSEQ$genome,
   id=G$GOSEQ$system, use_genes_without_cat=G$GOSEQ$use_genes_without_cat)
  title(main="GOSeq pwf Allgenes")
  if(sum(DEG.up)>1) {
   pwf <- nullp(DEG.up, G$GOSEQ$genome, G$GOSEQ$system)
   #rownames(pwf)<-sdata$REFSEQ # we're calling goseq() with gene system 'refGene'
   GO.wall.Up <- goseq(pwf, G$GOSEQ$genome,
    id=G$GOSEQ$system, use_genes_without_cat=G$GOSEQ$use_genes_without_cat)
   title(main="GOSeq pwf Upreg")
  }else{
   GO.wall.Up <- GO.wall[FALSE,]
  }
  if(sum(DEG.dn)>1){
    pwf <- nullp(DEG.dn, G$GOSEQ$genome, G$GOSEQ$system)
    #rownames(pwf)<-sdata$REFSEQ # we're calling goseq() with gene system 'refGene'
    GO.wall.Dn <- goseq(pwf, genome=G$GOSEQ$genome,
    id=G$GOSEQ$system, use_genes_without_cat=G$GOSEQ$use_genes_without_cat)
    title(main="GOSeq pwf Downregulated genes.")
   }else{
    GO.wall.Dn <- GO.wall[FALSE,]
   }
  dev.off();
  
  ## here's a good place to send a warning if some whitelisted GO terms are not available
  igo <- setdiff(G$Force_GO_Include, "GO:0000000")
  Missing_GO_terms <- igo[!(igo%in%GO.wall$category)]
  if(length(Missing_GO_terms)>0) # allow one for the default GO:00000
    warning(sprintf("Some %d Whitelisted GO terms from Force_GO_Include.csv not found in database: %s",
     length(Missing_GO_terms),
     paste(Missing_GO_terms, collapse=" ")))
  
  FilterGOSEQ <- function(GOR, PLIM) {
    # do a Benjamini-Hochberg correction of p-values.
    GOR$over_represented_padj = p.adjust(GOR$over_represented_pvalue,
                                         method=as.character(G$LIMIT$goseq_padj_method))
    GOR$under_represented_padj = p.adjust(GOR$under_represented_pvalue,
                                          method=as.character(G$LIMIT$goseq_padj_method))
    #filter reported set to something with a pvalue:
    GOR$minp <- apply(cbind( 
      GOR$over_represented_padj , GOR$under_represented_padj),
                      1,min)
    GOR <- subset(GOR,GOR$minp <= PLIM | GOR$category %in% igo)
    gots = select(GO.db,keys=as.character(GOR$category),
                  columns=c("GOID","TERM","ONTOLOGY","DEFINITION"),
                  keytype="GOID")
    colnames(gots) <- c("GOID","Term","Ontology","Definition")
    merge(GOR, gots, by.x="category",by.y="GOID", all.x=TRUE)
  }
  GO.wall    <- FilterGOSEQ(GO.wall   , PLIM=G$LIMIT$GO_PVAL*1.5)
  GO.wall.Up <- FilterGOSEQ(GO.wall.Up, PLIM=G$LIMIT$GO_PVAL*1.5)
  GO.wall.Dn <- FilterGOSEQ(GO.wall.Dn, PLIM=G$LIMIT$GO_PVAL*1.5)
  
  Check_Missing_ForcedGO(GO.wall,igo)
  
  if(!G$QUIET)Message_Generate(outfile)
  write.csv(GO.wall   ,outfile);
  write.csv(GO.wall.Up,GSEPD_GOUpFile(G));
  write.csv(GO.wall.Dn,GSEPD_GODownFile(G));
  
  message("Written GO categories, now reverse mapping");
  test.cats = c("GO:CC", "GO:BP", "GO:MF")
  gene2cat = getgo(rownames(pwf), G$GOSEQ$genome,G$GOSEQ$system, fetch.cats = test.cats)
  names(gene2cat) = rownames(pwf)
  cat2gene = reverseMap(gene2cat)
  gene2cat = reverseMap(cat2gene)
  
  GO.wall <- rbind(GO.wall.Dn, GO.wall.Up, GO.wall) ; rm(GO.wall.Dn, GO.wall.Up)
  GO.wall <- subset(GO.wall, !(duplicated(GO.wall$category)))
  #this will pick whoever was first, probably wall.Dn, in the case of duplications.

  #okay awesome, let's make a table of those genes in GO.wall with over_represented_pvalue and genes in sdata 
  OM=matrix(nrow=0,ncol=2); colnames(OM)<-c("category","ENTREZ");
  AllCategories <- unique( unlist(GO.wall$category) )
  for(gocat in AllCategories){
    GID=cat2gene[[gocat]] #as vector of strings, but numeric entrez ids
    GID=GID[GID %in% sdata$ENTREZ]
    if(length(GID)>0)
      OM=rbind(OM, cbind(rep(gocat,length(GID)), GID))
  }
  
  merged=merge(OM,sdata,by="ENTREZ")
  #now making the GO2 file out of just the single GOseq. 
  merged <- merge(merged, GO.wall, by="category", all.x=TRUE)
  #count genes per category:
  Repetition <- table(merged$category)
  merged$GO_GCount <- Repetition[merged$category];
  if(!G$QUIET)Message_Generate(outfile2)
  keepCol=c("REFSEQ","HGNC",G$C2T[1],G$C2T[2], "LOG2.X.Y.",  "PVAL",
            "PADJ",	"category",	"over_represented_pvalue",	"under_represented_pvalue",
            "over_represented_padj",	"under_represented_padj",
            "numDEInCat",	"numInCat",	"Term",	"Ontology")
 #keepCol[ !(keepCol %in% colnames(merged))]
  merged=subset(merged,merged$numInCat<800 |  merged$category %in% igo, select=keepCol)
  merged[,c(G$C2T[1],G$C2T[2], "LOG2.X.Y.")] = signif( merged[,c(G$C2T[1],G$C2T[2], "LOG2.X.Y.")], digits=3 )
  write.csv(merged,outfile2)
}

Check_Missing_ForcedGO <- function(go2, include_list){
  m <- include_list[  !(include_list%in% go2$category) ]
  if(length(m)>0)
    warning(sprintf("Trying to include some GO terms but they arent found by GO.db : %s",paste(m,collapse=" ")))
}


GSEPD_Export_DESeq<-function(G){
  colData<-G$sampleMeta
  rownames(colData)<-G$sampleMeta$Sample
  colData$Condition <- as.factor(colData$Condition)
  colData$Condition <- relevel(colData$Condition, G$Conditions[1])
  dds <- DESeqDataSetFromMatrix(countData = G$finalCounts,
                                colData = colData,
                                design = ~ Condition)
  return(dds)
}


GSEPD_CheckCounts <- function(GSEPD) {
  if(is.null(GSEPD$normCounts)) {
    #rld <- rlog()
    vsd <- DESeq2::varianceStabilizingTransformation(GSEPD_Export_DESeq(GSEPD), 
                                                     blind=GSEPD$vstBlind)
    #rlogMat <- assay(rld)
    vstMat <- assay(vsd)
    GSEPD$normCounts <- vstMat
  }
GSEPD
}

##
## Some helper functions.



RefSeq_to_EG <- function(nm){
  if(length(nm)>1)
    return(unlist(lapply(nm,RefSeq_to_EG)))
  if(length(nm)==0)
    return(NA)
  #else; do one:
  #hash::values(get("R2E", pkg_globals)[nm])
  get("R2E", pkg_globals)[[nm]]
}

EG_to_Name <- function(eg){
  if(length(eg)>1)
    return(unlist(lapply(eg,EG_to_Name)))
  if(length(eg)==0)
    return(NA)
  #else; do one:
  #hash::values(get("E2H", pkg_globals)[eg])
  get("E2H", pkg_globals)[[eg]]
}

Name_to_RefSeq <- function(x){
  if(length(x)>1)
    return(unlist(lapply(x,Name_to_RefSeq)))
  if(length(x)==0)
    return(NA)
  #else; do one:
  #hash::values(get("H2R", pkg_globals)[x])
  get("H2R", pkg_globals)[[x]]
}

RefSeq_to_Name <- function(x){
  if(length(x)>1)
    return(unlist(lapply(x,RefSeq_to_Name)))
  if(length(x)==0)
    return(NA)
  #else; do one:
  #hash::values(get("H2R", pkg_globals)[x])
  y = get("R2H", pkg_globals)[[x]]
  if(length(y)==0)
    return("NA")
  y
}


DisplayName <- function(txid){
  if(length(txid)>1)
    return(unlist(lapply(txid,DisplayName)))
  if(length(txid)==0)
    return("NA")
  #else; do one:
  #hash::values(get("R2H", pkg_globals)[txid])
  get("R2H", pkg_globals)[[txid]]
}







## of course now these tests wont work until after
# .onLoad has set up the hashes. 
#so this is the wrong place for tests...
if(FALSE) {
  RefSeq_to_EG("NM_153215")
  EG_to_Name("132228")
  Name_to_RefSeq("LSMEM2")
  
  #test:::
  stopifnot("BRCA1"==EG_to_Name(RefSeq_to_EG(Name_to_RefSeq("BRCA1"))))
  stopifnot("CD33"==EG_to_Name(RefSeq_to_EG(Name_to_RefSeq("CD33"))))
  stopifnot("CD33"==DisplayName(Name_to_RefSeq("CD33")) )
}


build_Annotation_Matrix <- function(nms){
  #from a list of NM refseq IDs, (and NR), we want a matrix of three columns
  O<-matrix(NA,nrow=length(nms),ncol=3)
  colnames(O)<-c("REFSEQ","HGNC","ENTREZ")
  O[,"REFSEQ"]<-nms;
  Es<-RefSeq_to_EG(nms)
  O[,"ENTREZ"]<-Es
  #EG to name doesnt like NAs.
  ROI <- !is.na(O[,"ENTREZ"])
  O[ROI,"HGNC"]<-EG_to_Name(O[ROI,"ENTREZ"])
  return(O)
}
  
#

EnsureCleanIDs <- function(NM){
 #make sure all NMs are available in R2E and R2H before it causes a crash
  hR2H <- get("R2H", pkg_globals)
  missingKeys <- NM[!(NM %in% names(hR2H))]
  if(length(missingKeys)>0) {
    for(j in 1:length(missingKeys))
      hR2H[[missingKeys[j]]] <- missingKeys[j]
    assign("R2H", hR2H, pkg_globals)
  }
  
  hR2E <- get("R2E", pkg_globals)
  missingKeys <- NM[!(NM %in% names(hR2E))]
  if(length(missingKeys)>0) {
    for(j in 1:length(missingKeys))
       hR2E[[missingKeys[j]]] <- missingKeys[j]
    assign("R2E", hR2E, pkg_globals)
  }
  
  hE2H <- get("E2H", pkg_globals)
  allEG <- as.character(unlist(as.list(hR2E)) )

  missingKeys <- allEG[!(allEG %in% names(hE2H))]
  if(length(missingKeys)>0) {
    for(j in 1:length(missingKeys))
      hE2H[[missingKeys[j]]] <- missingKeys[j]
    # their assigned HGNC is equal to their EntrezGeneID
    assign("E2H", hE2H, pkg_globals)
  }
  
}

###
## Summer 2013 - 2014
## rgsepd-0.3.3 KStamm 
## a tool to perform linear vector projection in GO-Term space
###

GSEPD_ProjectionProcessor <- function(GSEPD) {
  
  GSEPD <- GSEPD_CheckCounts(GSEPD) # make sure normCounts is calculated!
  finalCounts <- GSEPD$normCounts
  C2T <- GSEPD$C2T
  sampleMeta <- GSEPD$sampleMeta
  
  Type1=GSEPD$Conditions[1]
  Type2=GSEPD$Conditions[2]
  
  DefinedGroup <- subset(sampleMeta, sampleMeta$Condition %in% c(Type1, Type2))
  ArcheTypes <- as.character(DefinedGroup$Sample)
  G1=ArcheTypes[DefinedGroup$Condition == Type1];
  G2=ArcheTypes[DefinedGroup$Condition == Type2]
  cols=rep(1,ncol(finalCounts))
  pchs=rep(3,ncol(finalCounts))
  
  if(length(GSEPD$COLORS)!=3){
    stop("Vector of GSEPD$COLORS should be three elements (Group1, middle, Group2).")
  }#doesnt this really belong elsewhere. 
  
  cols[colnames(finalCounts) %in% G1] <- GSEPD$COLORS[1]
  cols[colnames(finalCounts) %in% G2] <- GSEPD$COLORS[3]
  pchs[colnames(finalCounts) %in% G1] <- 1
  pchs[colnames(finalCounts) %in% G2] <- 2
  
  #pull up the merged doc and grab the minor GO term
  M.data <- read.csv(GSEPD_MFile(GSEPD), as.is=TRUE, header=TRUE,row.names=1) 

  AssembleGOSTAT <- function(GOTERM){
    x=list();
    x$Term=GOTERM;
    DEG=subset(M.data,M.data$category==GOTERM)
    x$Name=DEG$Term.x[1]
    x$DataProjection <- ExtractProjection(GSEPD, DEG$REFSEQ ,
                                          PRINTING = FALSE, DRAWING = FALSE)
    x
  }
  
  tcats <- table(M.data$category)
  cats <- unique( subset( M.data, M.data$over_represented_padj.x < GSEPD$LIMIT$GO_PVAL)$category)
  #omit those with too few or too many
  cats = setdiff(cats, names(tcats)[tcats<GSEPD$MinGenesInSet | tcats>GSEPD$MaxGenesInSet]  ) 

  if(length(cats)>1) {
    outfile=paste(GSEPD$Output_Folder, "/SCA.GSEPD.",C2T[1],".",C2T[2],".pdf",sep="")
    Message_Generate(outfile)
    pdf(outfile)
    for(i in seq(1,length(cats)-1,2)){
      #print(paste(cats[i],cats[i+1]))
      DIM_1=AssembleGOSTAT(cats[i])
      DIM_2=AssembleGOSTAT(cats[i+1])
      xs=(DIM_1$DataProjection$alpha) #GOSet 1 axis score
      ys=(DIM_2$DataProjection$alpha) #GOSet 2 axis score
      plot(x=xs, y=ys, main=paste(ncol(finalCounts), "Samples by 2 GO:Terms"),
           xlab=paste(Type2,DIM_1$Name,Type1, sep=" - "), ylab=paste(Type2,DIM_2$Name,Type1, sep=" - "),
           pch=pchs, col=cols )
      legend("topleft",legend=c(GSEPD$Conditions[1],GSEPD$Conditions[2],"Other"),pch=c(1,2,3),col=c(GSEPD$COLORS[1],GSEPD$COLORS[3],1))
    }
    dev.off()
  }else{
    warning("Skipping generation of SCA.GSEPD.pdf because there aren't enough enriched GO Categories.")
  }
  
  if(length(cats)>0) {
    message("Calculating Projections and Segregation Significance")
    OM=matrix(nrow=length(cats), ncol=ncol(finalCounts))
    WhiteOut <- OM;  G1OM <- OM;  G2OM <- OM;
    Segregation_PV=rep(1,nrow(OM)) # see GSEPD$LIMIT$Seg_P later.
    Segregation_Val=rep(1,nrow(OM)) # see GSEPD$LIMIT$Seg_P later.
    
    colnames(WhiteOut)<-colnames(finalCounts)
    rownames(OM)<-cats
    rownames(WhiteOut)<-cats
    rownames(G1OM)<-cats
    rownames(G2OM)<-cats
    names(Segregation_PV)<- cats
    names(Segregation_Val)<- cats
    
    for(i in 1:nrow(OM)){
      ExDP <- AssembleGOSTAT(cats[i])$DataProjection
      OM[i,] <-ExDP$alpha
      WhiteOut[i,]<-ExDP$beta
      G1OM[i,] <-ExDP$gamma1
      G2OM[i,] <-ExDP$gamma2
      #Segregation_P[i] <- Resampled_Significance.t(GSEPD,data.frame(alpha=ExDP$alpha, type=GSEPD$sampleMeta$Condition ), GSEPD$Conditions)
      O <- Resampled_Significance.k(GSEPD, 
                      ROI=M.data$REFSEQ[M.data$category==cats[i]],
                      SOI=ArcheTypes)
      Segregation_PV[i] <- O$PV
      Segregation_Val[i] <- O$Validity
    }
    colnames(OM)<-colnames(finalCounts)
    colnames(WhiteOut)<-colnames(finalCounts)
    colnames(G1OM)<-colnames(finalCounts)
    colnames(G2OM)<-colnames(finalCounts)
    SIGFIG=3
    write.csv(signif(OM,SIGFIG), paste(GSEPD$Output_Folder, "/GSEPD.Alpha.", C2T[1],".",C2T[2],".csv",sep=""))
    write.csv(signif(WhiteOut,SIGFIG), paste(GSEPD$Output_Folder, "/GSEPD.Beta.", C2T[1],".",C2T[2],".csv",sep=""))
    write.csv(cbind(Segregation_Val, Segregation_PV), GSEPD_Seg_File(GSEPD))
    write.csv(signif(G1OM,SIGFIG), GSEPD_HMG1CSV_File(GSEPD))
    write.csv(signif(G2OM,SIGFIG), GSEPD_HMG2CSV_File(GSEPD))
    
    GOPs <- rep(0,length(cats))
    GONames <- rep("",length(cats))
    for(i in 1:length(cats)) { 
      roi <- (M.data$category == cats[i]) #find the entry in Mdata
      GONames[i] <- sprintf("%s %s",M.data$Term.x[roi][1], M.data$category[roi][1]); 
      GOPs[i] <- M.data$over_represented_padj.x[roi][1];
      #if this GOSet fails to separate the classes, we can drop it from further processing
      if( Segregation_PV[i] < GSEPD$LIMIT$Seg_P){
        #if it segregates let's make a pairs plot to go with
        deg_ngenes <- sum(roi)
        if(deg_ngenes >= 2 && deg_ngenes <= 10){# only on those sets with a decent number of genes
          GSEPD_Pairs_Plot(GSEPD, M.data$REFSEQ[roi], GONames[i], GOPs[i], Segregation_PV[i])
        }
        pdf(paste(GSEPD$Output_SCGO,"/Scatter.",C2T[1],".",C2T[2],".GO",substring(cats[i],4),".pdf",sep=""))
          GSEPD_PCA_Spec(GSEPD=GSEPD,GOT=cats[i],MDATA=M.data)
          title(sub=sprintf("%d Genes / %d Samples / GOSeq p=%f / segregation p=%f",deg_ngenes, ncol(finalCounts), GOPs[i], Segregation_PV[i]))
        dev.off()
      }
    }
    
    #we'll use the combination to choose great sets
    GO_SumPs <- GOPs + Segregation_PV
    
    Message_Generate(GSEPD_HMA_File(GSEPD))
   
    if(length(G1)>1 && nrow(OM)>1)
      OM.A1 <- apply(OM[,G1], 1, mean)-min(OM)+1
    else
      OM.A1 <-OM[,G1] - min(OM)+1
    
    if(length(G2)>1 && nrow(OM)>1)
      OM.A2 <- apply(OM[,G2], 1, mean)-min(OM)+1
    else
      OM.A2 <-OM[,G2] - min(OM)+1
    
    OM.min <- apply(cbind(OM.A1,OM.A2),1,min)#*0.90
    OM.max <- apply(cbind(OM.A1,OM.A2),1,max)#*1.10
    #Z-scored OutMatrix
    zOM <- OM-min(OM)+1;
    for(i in 1:nrow(zOM)){
      zOM[i, zOM[i,]< OM.min[i] ] <- OM.min[i]
      zOM[i, zOM[i,]> OM.max[i] ] <- OM.max[i]
      zOM[i,] <- (zOM[i,] - OM.min[i]) / (OM.max[i] - OM.min[i])
    }#goes pretty much 0-1;

    #generate the asterisks you see in the heatmap
    #first lets get some Z-scores on the projection distance
    zWhiteOut <- t(scale(t(WhiteOut)))
    cellnote=matrix(" ", nrow=nrow(zOM),ncol=ncol(zOM))
    for(j in 1:nrow(zOM)){
     cellnote[j,  zWhiteOut[j,] > GSEPD$VECTOR_DISTANCE_ZTHRESH_Moderate] <- "." 
     cellnote[j,  zWhiteOut[j,] > GSEPD$VECTOR_DISTANCE_ZTHRESH_Severe ] <- rawToChar(as.raw(149)) #a fat circle bullet character
    }
    
    ColumnLabels <- colnames(zOM);
    for(j in 1:length(ColumnLabels))
      ColumnLabels[j] <- paste(sampleMeta$SHORTNAME[sampleMeta$Sample==ColumnLabels[j]],
                               sampleMeta$Condition[sampleMeta$Sample==ColumnLabels[j]])
    
    ColLabelColors <- rep("black",ncol(OM));
    names(ColLabelColors) <- colnames(OM)
    ColLabelColors[G1] <- GSEPD$COLORS[1];
    ColLabelColors[G2] <- GSEPD$COLORS[3];
    
    #which rows are worth looking at??
    sr=1:length(GO_SumPs) 
    sr=sort(GO_SumPs, decreasing=FALSE, index.return=TRUE)$ix[1:min(GSEPD$MAX_GOs_for_Heatmap,length(cats))]
    #and remove those non-significant
    sr <- sr[ GO_SumPs[sr] <= (GSEPD$LIMIT$GO_PVAL + GSEPD$LIMIT$Seg_P)] ;
    
    if(length(sr) > 1) {
      RowLabelColors <- rep("black",length(sr));
      names(RowLabelColors)<-cats[sr]
      sMdata<-subset(M.data, !duplicated(M.data$category), select=c("category","GOSEQ_DEG_Type"))
      for(j in 1:length(sr)){
        cj<-cats[sr[j]];DEGType<-sMdata$GOSEQ_DEG_Type[sMdata$category == cj];
        RowLabelColors[j] <- ifelse(DEGType == "Up",GSEPD$COLORS[3],
                                    ifelse(DEGType == "Down",GSEPD$COLORS[1],
                                           GSEPD$COLORS[2]))
      } ; rm(sMdata)
      
      pdf(GSEPD_HMA_File(GSEPD), height=6+length(sr)/7, width=6+ncol(zOM)*0.33)
      heatmap.2(zOM[sr,], labRow=GONames[sr],
            scale="none", trace="none", margins=c(10,35),
            cexRow=1.25, labCol=ColumnLabels, cellnote=cellnote[sr,],
            notecex=3, notecol="white",
            ColSideColors=ColLabelColors, RowSideColors=RowLabelColors,
            col=GSEPD$COLORFUNCTION);
      dev.off()
      
      #then plot HMG#####
      #it's overlaying the zOM
      #but for the HMG file now I need to make a new 0-1 score from the G1OM/G2OM matrices.
      zOM[,] <- 0.5 ; #default all to indeterminate/black
      zOM[G1OM < 0.45] <- 0.35 #dark green
      zOM[G1OM < (0.45*(2/3)) ] <- 0 # bright green
      zOM[G2OM < 0.45] <- 0.65 # dark red
      zOM[G2OM < (0.45*(2/3)) ] <- 1 # bright red
                   
      pdf(GSEPD_HMG_File(GSEPD), height=6+length(sr)/7, width=6+ncol(zOM)*0.33)
      heatmap.2(zOM[sr,], labRow=GONames[sr],
                scale="none", trace="none", margins=c(10,35),
                cexRow=1.25,labCol=ColumnLabels,
                ColSideColors=ColLabelColors, RowSideColors=RowLabelColors,
                col=GSEPD$COLORFUNCTION);
      dev.off()
      
    }else{
      warning("Not generating HMA/HMG files:  <2 significant rows. See your GOSEQ and Segregation tables for details.")
    }
    
    #for the rows seen in the heatmap...
    for(j in sr){ #make lots of scatter plots, one for each GO term with some enrichment
      thisDEG=subset(M.data, M.data$category==cats[j])
      if( nrow(thisDEG) >= GSEPD$MinGenesInSet ) { 
#thought this would be taken care of above, but the GO term whitelist could create entries with invalid gene counts.
        pdf(paste(GSEPD$Output_SCGO,"/GSEPD.", C2T[1],".",C2T[2],".GO",substring(cats[j],4),".pdf",sep=""))
        nGenes=length(unique(thisDEG$REFSEQ))
        if(nGenes>1){
          for(i in seq(1,nGenes-1,2))
              ExtractProjection(GSEPD, txids = unique(thisDEG$REFSEQ),
                                DRAWING=TRUE, GN=c(i,i+1),PRINTING=FALSE,
                                plotTitle=thisDEG$Term.x[1])
        }
        dev.off();
      }
    }

  }else{ #length(cats)<1
    warning("GSEPD : Can't make output heatmap images when zero GO-Categories enriched.")
  }

}  # end GOCATPROCESSOR for Type1, Type2

GSEPD_Pairs_Plot <- function(GSEPD, txIDs, GO_Term, GO_P, Seg_P){
  
  fc <- GSEPD$normCounts[txIDs,]
  rownames(fc) <- DisplayName(txIDs)
  
  Sanitized_GOName <- strsplit(GO_Term,":")[[1]] #assuming this string ends with GO:NNNN, we cut at the colon
  outfile=sprintf("%s/Pairs.%s.%s.GO%s.pdf", GSEPD$Output_SCGO , GSEPD$C2T[1], GSEPD$C2T[2],
                  Sanitized_GOName[length(Sanitized_GOName)] )
  
  cols=rep(1,ncol(fc))
  cols[as.character(GSEPD$sampleMeta$Condition)==GSEPD$Conditions[1]]=GSEPD$COLORS[1]
  cols[as.character(GSEPD$sampleMeta$Condition)==GSEPD$Conditions[2]]=GSEPD$COLORS[3]
  pchs=rep(3,ncol(fc));
  pchs[as.character(GSEPD$sampleMeta$Condition)==GSEPD$Conditions[1]]=1
  pchs[as.character(GSEPD$sampleMeta$Condition)==GSEPD$Conditions[2]]=2
  
  square_dimension = length(txIDs)*1.55+2
  pdf(outfile, width = square_dimension, height = square_dimension)
  pairs( t(fc) , main=GO_Term,
        sub=sprintf("%d Genes / %d Samples / GOSeq p=%f / segregation p=%f",length(txIDs), ncol(fc), GO_P, Seg_P),
        pch=pchs, col=cols)
  dev.off();
  
}

GSEPD_INIT <- function( Output_Folder="OUT" ,finalCounts=NULL, sampleMeta=NULL,
                        DESeqDataSet = NULL, renormalize=TRUE, vstBlind=TRUE,
                        COLORS = c("green", "gray", "red"),
                        C2T = "x" ){
  
  GSEPD=list(); #master object antipattern
  
  if(is.null(DESeqDataSet)){
  #old interface, expect FC and SM.
    if(is.null(finalCounts) || is.null(sampleMeta)){
      stop(" not enough data given, you must specify either DESeqDataSet or finalCounts and sampleMeta")
    }else{#this would be a nice place to sanity check
      sampleMeta$Sample <- as.character(sampleMeta$Sample)
      sampleMeta$Condition <- as.character(sampleMeta$Condition)
      GSEPD$finalCounts <- finalCounts
      GSEPD$sampleMeta <- sampleMeta
    }
  }else{
    #new interface, DDS given.
    if(is.null(finalCounts) || is.null(sampleMeta)){
      GSEPD$finalCounts <- counts(DESeqDataSet)
      GSEPD$sampleMeta <- DESeqDataSet@colData
    }else{
      stop(" too much data given, you must specify either DESeqDataSet or finalCounts and sampleMeta")
    }
  }
  
  KeepRows<-rowSums(GSEPD$finalCounts)>0  & !is.na(rowSums(GSEPD$finalCounts))
  if(sum(KeepRows) < nrow(GSEPD$finalCounts))
     message(sprintf("Keeping rows with counts (%d of %d)",sum(KeepRows),length(KeepRows))) 
  GSEPD$finalCounts <- GSEPD$finalCounts[KeepRows,] ;rm(KeepRows)
     
  
  # if we do not pre-load G$normCounts, then GSEPD_CheckCounts() will run DESEQ's VST
  # but the user could ask to keep the input as given directly
  if(!renormalize){
   GSEPD$normCounts = GSEPD$finalCounts
  }
  
  
  GSEPD$Output_Folder = Output_Folder #new files are generated into this sub-folder
  
  if(!(file.exists(GSEPD$Output_Folder)))
    dir.create(GSEPD$Output_Folder)
  
  GSEPD$Output_SCGO <- paste(GSEPD$Output_Folder,"/SCGO",sep="")
  
  if(!(file.exists(GSEPD$Output_SCGO)))
    dir.create(GSEPD$Output_SCGO)
  
  GSEPD$MinGenesInSet <- 2  ## filters which GOTerm/GeneSets need to be displayed
  GSEPD$MaxGenesInSet <- 30 #preventing the analysis of enormous sets
  
  GSEPD$LIMIT <- list(HARD=TRUE,  # should I stick with the given thresholds, or let them vary, default: stick to it
                      baseMean=20,  # defines which genes are expressed
                      LFC=1, # defines which genes are differentially expressed for the purposes of gene set enrichment
                      PADJ=0.050,  # defines which genes are differentially expressed for the purposes of gene set enrichment
                      GO_PVAL=0.050, # defines which pathways are to be included in the heatmap figure (MERGE.over_represented_padj < x), using GOSeq's p value after p.adjust(BH)                  
                      goseq_padj_method="BH", # given to p.adjust(...,method=
                      Seg_P=0.050 ) #only PCA/Scatter plot those GOSets with segregating ability.
  
  GSEPD$Segregation_Precision <- 0.01 #about how certain do we have to be in the permuted kmeans. We'll empirically calculate between 1 and 4 times the reciprocal of this number. See GroupSignificance.R for permutation loops.

  GSEPD$MAX_GOs_for_Heatmap <- 40 #caps the size of the final heatmap to only the N most significant sets (by GOP+SegP)
  
  GSEPD$MAX_Genes_for_Heatmap <- 50 #caps the size of the DEG heatmap to only the N most significant Genes
          #in the event you have more than that you'll have to see the .Annote table
          #not applicable if LIMIT$HARD == TRUE, we'll report all of them
  
  GSEPD$COLORS <- COLORS #the heatmap (AND OTHER PLACES) will use this scale

  GSEPD$C2T_Delimiter <- C2T # five items of A versus four items of B is labeled Ax5.Bx4 . choose a symbol you don't use in condition names!
  
  #force the legend to appear in a vacant corner of the plot.
  #but I don't have a good way of choosing the vacant corner yet
  GSEPD$PCA_LEGEND <- "topright"
  
  GSEPD$QUIET <- FALSE #when true, most status and progress messages are suppressed.
  
  #for the heatmap and vector projection's color definition
  #this is a scale between group 1 and group2's profiles.
  #by default I double the first and last entry, so the center is squished.
  GSEPD$COLORFUNCTION <- colorRampPalette( c(GSEPD$COLORS[1],GSEPD$COLORS[1],
                                             GSEPD$COLORS[2],
                                             GSEPD$COLORS[3],GSEPD$COLORS[3] ))
  
  #we set a cutoff for how divergent a sample is before being marked on the heatmap.
  GSEPD$VECTOR_DISTANCE_ZTHRESH_Moderate <- 2
  GSEPD$VECTOR_DISTANCE_ZTHRESH_Severe <- 3
  #value is the z-score of the distance of all samples to the line
  
  #BY default empty
  GSEPD$EXCLUDES<-c("NM_0000000"); #vector of NM ids as strings
  GSEPD$Force_GO_Include<-c("GO:0000000"); #vector of GO ids as strings
  
  # allow user to change vstBlind setting
  GSEPD$vstBlind=vstBlind; # used during DESeq2::varianceStabilizingTransformation
  
  
  #theoretically you can change the background used for goseq
  #but i've only ever used/tested Entrez IDs on hg19
  GSEPD$GOSEQ <- list(genome="hg19" ,
                      system="knownGene",
                      use_genes_without_cat=TRUE)
  
  
  GSEPD$GeneIDSystem <- list(Transcript="REFSEQ",
                             GeneID="ENTREZ",
                             GeneName="HGNC")
  
  
  
  return(GSEPD)
}

\documentclass[12pt]{article}
\usepackage{natbib}
\usepackage[margin=1in]{geometry}
% !Rnw weave = knitr 
%\VignetteEngine{knitr::knitr}
%\VignetteIndexEntry{An Introduction to the rgsepd package}
\begin{filecontents*}{rgsepd.bib}
  @Article{DESeq,
    title = {Moderated estimation of fold change and dispersion for RNA-Seq data with DESeq2},
    author = {Michael I Love and Wolfgang Huber and Simon Anders},
    year = {2014},
    journal = {bioRxiv},
    doi = {10.1101/002832},
    url = {http://dx.doi.org/10.1101/002832},
  }

@Article{GOSeq,
AUTHOR = {Young, Matthew and Wakefield, Matthew and Smyth, Gordon and Oshlack, Alicia},
TITLE = {Gene ontology analysis for RNA-seq: accounting for selection bias},
JOURNAL = {Genome Biology},
VOLUME = {11},
YEAR = {2010},
NUMBER = {2},
PAGES = {R14},
URL = {http://genomebiology.com/2010/11/2/R14},
DOI = {10.1186/gb-2010-11-2-r14},
PubMedID = {20132535},
ISSN = {1465-6906},
ABSTRACT = {We present GOseq, an application for performing Gene Ontology (GO) analysis on RNA-seq data. GO analysis is widely used to reduce complexity and highlight biological processes in genome-wide expression studies, but standard methods give biased results on RNA-seq data due to over-detection of differential expression for long and highly expressed transcripts. Application of GOseq to a prostate cancer data set shows that GOseq dramatically changes the results, highlighting categories more consistent with the known biology.},
}

@Manual{Validity,
    title = {V-Measure: A conditional entropy-based external cluster evaluation
measure},
    author = {Andrew Rosenberg and Julia Hirschberg},
    year = {2007},
    note = {Department of Computer Science
Columbia University
New York, NY 10027 },
    url = {http://www1.cs.columbia.edu/\~amaxwell/pubs/v\_measure-emnlp07.pdf},
  }
  
@Article{Stamm2019,
    title = {GSEPD: a Bioconductor package for RNA-seq gene set enrichment and projection display},
    author = {Karl Stamm and Aoy Tomita-Mitchell and Serdar Bozdag},
    year = {2019},
    doi = {10.1186/s12859-019-2697-5},
    journal = {BMC Bioinformatics},
    publisher = {Springer Nature},
    volume = {20},
    number = {1},
    pages = {115},
    issn = {1471-2105},
    abstract = {RNA-seq, wherein RNA transcripts expressed in a sample are sequenced and quantified, has become a widely used technique to study disease and development. With RNA-seq, transcription abundance can be measured, differential expression genes between groups and functional enrichment of those genes can be computed. However, biological insights from RNA-seq are often limited by computational analysis and the enormous volume of resulting data, preventing facile and meaningful review and interpretation of gene expression profiles. Particularly, in cases where the samples under study exhibit uncontrolled variation, deeper analysis of functional enrichment would be necessary to visualize samples' gene expression activity under each biological function.},
    url = {https://bmcbioinformatics.biomedcentral.com/articles/10.1186/s12859-019-2697-5},
  }
  
\end{filecontents*}
 

\begin{document}
%\SweaveOpts{concordance=TRUE}
\bibliographystyle{plainnat}

\title{R/GSEPD Tutorial \\ Gene Set Enrichment and Projection Displays}
\author{Karl Stamm \--- karl.stamm@gmail.com \--- }

<<setup_latex, include=FALSE, cache=FALSE, echo=FALSE>>=
Sys.setenv(TEXINPUTS=getwd(),
           BIBINPUTS=getwd(),
           BSTINPUTS=getwd())
library(xtable)
@

\maketitle

\section{Introduction}
\texttt{GSEPD} is a package for streamlining RNA-Seq data analysis, targeting complex samples with low replicate count such as human tissues, where all factors (metabolic, genetic, etc) cannot be controlled statistically \citep{Stamm2019}. As a prerequisite, you need only your multiple samples' count data as a matrix whose columns are samples and rows are RefSeq NM and NR transcript identifiers. A second matrix associates sample identifiers with treatment/condition.  Given both datasets, GSEPD will automate differential expression via DESeq2 \citep{DESeq}, functional analysis via GOSeq \citep{GOSeq}, generate heatmaps of gene expression for significantly differentially expressed genes, and subsets of genes defined by the significantly enriched GO Terms.

After gene sets are detected from a differential expression analysis, the results are merged into a novel `projection display' wherein each sample is scored according to each condition's multidimensional average expression. When the treatment samples are found to have a perturbed expression profile for a particular GO Term (geneset), all samples are scored on an axis ranging from control to treatment condition, and outliers or anomalous samples are readily apparent. Clustering quality of samples in a given geneset-space is quantified by the cluster's ``Validity score'' \citep{Validity} and an empirical permutation derived p-value. GO Terms with more genes than samples in your comparison will randomly appear enriched, so the Segregation P-value is used to determine if a GO Term is significantly segregating your samples. 

\section{Usage}
You'll need a prepared matrix of read-counts per transcript (Table \ref{MyT1}.) You can use HTSeq or RSEM or coverageBed, or any other generation method, so long as it ends with a table of counts by transcript ID. This software comes pre-packaged with a dataset based on the IlluminaBodyMap project, counted with coverageBed. The second prerequisite is a metadata table associating sample identifiers with their test-condition and a nickname to annotate figures with (see Table \ref{MyT2} for the included sample). Alternatively, the manual/Vignette for DESeq2 describes how to generate a dataset object from HTSeq read counts, you can also initialize GSEPD with the DESeqDataSet object instead of the counts matrix. By default this table will be normalized by DESeq during processing, but if you have a pre-normalized table, you can prevent the double normalization by setting renormalize=FALSE in the INIT() routine. 

\subsection{Naming Conventions}
In \texttt{R}, column names are not allowed to have spaces or certain special characters like $+$ or \/. As your sample names are the columns of the count table, this implies your sample names may not have special characters or spaces. When you load a table with invalid column headers, \texttt{R} may silently convert invalid characters into periods, thus ``Sample 1'' becomes ``Sample.1''. If your metadata table (where samples must be annotated) matches the original count table, it won't match this converted name, and you'll either get an error about samples not being found, or worse, an apparently successful run with invalid data. In later stages of the \texttt{GSEPD} process your test conditions also become column headers, and spaces will cause an error before completion. It's better to compare groups \texttt{`test'} vs \texttt{`control'} than \texttt{`lung tissue'} vs \texttt{`healthy(-ish) person'}.

<<dataload>>=
library(rgsepd)
set.seed(1000) #fixed randomness
data("IlluminaBodymap" , package="rgsepd")
data("IlluminaBodymapMeta" , package="rgsepd")
@

<<MyT1CodeBlock, echo = FALSE, results = 'hide'>>=
T1 <- head(IlluminaBodymap,n=10L)[,c(1,2,3,4,5,9,13)]
T2 <- head(IlluminaBodymapMeta)
@

<<MyLaTeXT1Caption, echo = FALSE, results = 'asis'>>=
xT<-xtable(T1, caption ="First few rows of the included IlluminaBodymap dataset. See \\texttt{?IlluminaBodymap} for more details.", label = 'MyT1')
print.xtable(xT, scalebox=0.75)
xtable(T2, caption ="First few rows of the included IlluminaBodymapMeta dataset. See \\texttt{?IlluminaBodymapMeta} for more details. These are easy to build with a spreadsheet, saved to csv and R's builtin \\texttt{?read.csv}", label = 'MyT2')
@

Next we'll sub-select $5,000$ genes from this set for speed.  Initialize the GSEPD object with the \tt GSEPD\_INIT \rm function. Finally, to indicate which conditions will be tested as this dataset includes samples from `condition' A, B, and C, we use \tt GSEPD\_ChangeConditions\rm.


<<setup>>=
isoform_ids <- Name_to_RefSeq(c("GAPDH","HIF1A","EGFR","MYH7","CD33","BRCA2"))
rows_of_interest <- unique( c( isoform_ids ,
                    sample(rownames(IlluminaBodymap),
                    size=5000,replace=FALSE)))
G <- GSEPD_INIT(Output_Folder="OUT",
          finalCounts=round(IlluminaBodymap[rows_of_interest , ]),
          sampleMeta=IlluminaBodymapMeta,
            COLORS=c(blue="#4DA3FF",black="#000000",gold="#FFFF4D"))
G <- GSEPD_ChangeConditions( G, c("A","B"))
@

This should only take a moment, and create the folder \texttt{OUT} which will hold your generated results. If you're familiar with R objects, you can explore the \texttt{G} object here and change default parameters, all set by \texttt{GSEPD\_INIT}. We'll change some parameters now to demonstrate:


<<ParameterChanging, cache=FALSE>>=
  G$MAX_Genes_for_Heatmap <- 30
  G$MAX_GOs_for_Heatmap <- 25
  G$MaxGenesInSet <- 12
  G$LIMIT$LFC <- log( 2.50 , 2 )
  G$LIMIT$HARD <- FALSE
@

Here we changed five default settings on the \texttt{G} master object. The parameters \texttt{MAX\_Genes\_for\_Heatmap} and \texttt{MAX\_GOs\_for\_Heatmap} cap how many rows you'll see on your final differential expression heatmap  (Figure \ref{fig:HM}) and the projection HMA file (Figure \ref{fig:HMA}), choosing the most significant rows so your figures are shorter. If you'd like a figure containing everything, make these values large. 

The parameter \texttt{MaxGenesInSet} controls the size of evaluated GO-Terms. Default is 30, here we reduce it to 12 for speed. Calculating projection significance for large sets can be slow. Also see \texttt{MinGenesInSet} for culling niche gene sets. The goal here is to limit our results to gene sets which are not too broad and not too narrow. 

The parameter \texttt{LIMIT\$LFC} is the $\log_2$ minimum foldchange required for significance, here we've set it to require 250\% expression up or down (default is 200\%, at LFC=1). Finally \texttt{LIMIT\$HARD} if \texttt{TRUE} (the default), means figures and plots will respect the specified p-value limits. Sometimes your comparison won't have any significant genes or GO-terms and later stages of the pipeline will error or quit. To force generation of all stages and plots of less-than-strictly significant sets, we have set the \texttt{LIMIT\$HARD=FALSE}. You'll see messages during processing if very few genes would be strictly significant, as the system adjusts the threshold automatically. By default, limits are hard at $p=0.05$. 

Now we're ready to run the pipeline:

<<GSEPD_Process, cache=FALSE>>=
  G <- GSEPD_Process( G )
@

This step can take a few minutes on a full genome-wide dataset. If you change something and re-run GSEPD will reuse any files it finds with the same filename, so you don't have to wait for each step again, unless the filenames change. GSEPD's automation steps will convert gene identifiers, and GOSeq can take a few minutes as it runs on three differential expression sets (the upregulated, the downregulated, and the combined). All of these results are saved as CSV files under the \texttt{OUT} folder.

We save the G object from a \tt GSEPD\_Process \rm 
routine, to retain information such as the normalized counts (wherein DESeq adjusted for library sequencing depths). This object will be passed to further visualizations, such as heatmaps and PCA.

<<GSEPD_Heatmap_-_PCA>>=
  print(isoform_ids)
  GSEPD_Heatmap(G,isoform_ids)
  GSEPD_PCA_Plot(G)
@



\section{Results}
Several files are generated from each run. When \tt GSEPD\_Process\rm 
 is invoked the pre-specified conditions are compared, or when \tt GSEPD\_ProcessAll\rm 
 is invoked, each condition is tested against all others.  For each comparison, files with the comparison listed in their filename are generated.  For a condition named ``A'' with $N$ samples, versus ``B'' with $M$ samples,  your normalized counts file will be written to \tt OUT\textbackslash DESEQ.counts.AxN.BxM.csv\rm 
for example. If one of your conditions has the letter \texttt{x} in it, please change the delimiter with something like \texttt{G\$C2T\_Delimiter <- 'z'} or other unused character.
 
\subsection{Heatmap Organizational Clustering}
Each generated heatmap figure organizes the rows and columns such that similar profiles are adjacent. For this we use the default methods of \tt gplots::heatmap.2 \rm 
which calls \tt hclust \rm
on the supplied data. For gene heatmaps where you see numbers in each cell, representing the gene's expression value calculated by \tt DESeq2::varianceStabilizingTransformation \rm. For users who have pre-normalized their datasets, systemic re-normalization can be disabled at initialization with the \texttt{renormalize} parameter.
The magnitude of a gene's expression might dominate the heirarchical clustering, so scaling is warranted. \texttt{GSEPD} will scale gene expression values within each row(gene) as a normal Gaussian by subtracting the row's mean and dividing out the standard deviation. Therefore it is dependent on the samples used in the figure, and heirarchical clustering with complete linkage is not guaranteed to be stable. To ensure some values of each specified color, the normalized color data is capped to a specifiable minimum and maximum (default 3) before heatmap.2's clustering is performed.



<<MyT3>>=
Annotated_Filtered <- read.csv("OUT/DESEQ.RES.Ax4.Bx8.Annote_Filter.csv",
                      header=TRUE,as.is=TRUE)
@

<<MyLaTeXT3Caption, echo = FALSE, results = 'asis'>>=
xT<-xtable(head(Annotated_Filtered, n=10L),
           caption ="First few rows of OUT/DESEQ.RES.Ax4.Bx8.Annote\\_Filter.csv which contains the DESeq results, cropped for significant results, and annotated with gene names (the HGNC Symbol).", label = 'Table_Annote')
print(xT, scalebox=0.70, include.rownames=FALSE)
@


<<MyLaTeXT5Caption, echo = FALSE, results = 'asis'>>=
Merge_File <- read.csv("OUT/GSEPD.RES.Ax4.Bx8.MERGE.csv",
                      header=TRUE,as.is=TRUE, nrows=20)
xT<-xtable(head(Merge_File, n=15L),
           caption ="First few rows of OUT/GSEPD.RES.Ax4.Bx8.MERGE.csv showing enriched GO Terms, and each terms' underlying gene expression averages per group. This data is central to the rgsepd package, defining the group centroids per GO-Term. It consists of the cross-product of the GO enrichment statistics and the DESeq differential expression and summarization. ", label = 'MyT5')
print(xT, scalebox=0.50, include.rownames=FALSE)
@



\begin{figure}[p]
    \centering
    \includegraphics[width=0.45\textwidth, type=pdf, ext=.pdf, read=.pdf]{OUT\Sexpr{.Platform$file.sep}GSEPD.PCA_AG.Ax4.Bx8}
    \caption{OUT\textbackslash GSEPD.PCA\_AG.Ax4.Bx8.pdf is the Principle Components Analysis of All Genes, from the comparison Ax4 vs Bx8 under run OUT. This function annotates the top four major genes underlying each principle component dimension along each axis (by maximum absolute weight). Samples from the tested condition are marked in the comparison colors, here blue and gold. All genes and all samples are included. A true outlier sample can direct the principle components away from the differentiating genes, and all tested samples can show as a single cluster.}
    \label{fig:PCA_AG}
\end{figure}

\begin{figure}[p]
    \centering
   \includegraphics[width=0.45\textwidth, type=pdf, ext=.pdf, read=.pdf]{OUT\Sexpr{.Platform$file.sep}GSEPD.PCA_DEG.Ax4.Bx8}
    \caption{OUT\textbackslash GSEPD.PCA\_DEG.Ax4.Bx8.pdf is the Principle Components Analysis of only Differentially Expressed Genes, from the comparison Ax4 vs Bx8 under run OUT. This function annotates the top four major genes underlying each principle component dimension along each axis (by maximum absolute weight). Samples from the tested condition are marked in the comparison colors, here blue and gold, with the non-comparison samples marked as black `Other'. \textbf{Because we're only reviewing genes found to be differentially expressed, this plot is guaranteed to show separation of your samples, sometimes spuriously.} }
    \label{fig:PCA_DEG}
\end{figure}


\begin{figure}[p]
    \centering
    \includegraphics[width=0.45\textwidth, type=png, ext=.png, read=.png]{OUT\Sexpr{.Platform$file.sep}DESEQ.Volcano.Ax4.Bx8}
    \caption{OUT\textbackslash DESEQ.Volcano.Ax4.Bx8.png is the `volcano' plot from the comparison Ax4 vs Bx8. Here, the horizontal axis is the relative fold-change between conditions, and the vertical is significance. A left-right balanced figure indicates similar numbers of genes found up and down-regulated. The bundled IlluminaBodymap dataset does not have biological replicates, causing the Volcano plot to show too many significant genes. }
    \label{fig:Volcano}
\end{figure}

\begin{figure}[p]
    \centering
    \includegraphics[width=0.9\textwidth, type=pdf, ext=.pdf, read=.pdf]{OUT\Sexpr{.Platform$file.sep}GSEPD.HMA.Ax4.Bx8}
    \caption{OUT\textbackslash GSEPD.HMA.Ax4.Bx8.pdf is the projection display summary heatmap from the comparison Ax4 vs Bx8. Here, as in a normal heatmap, your samples are columns, and rows are GO Terms with significant segregation ability. All rows and columns are arranged to cluster. The color in each cell represents the sample's Alpha score for that GO Term, with blue indicating similarity to class `A', and the gold indicating similarity to class `B'. The unlabeled top row indicates the comparison categories, also seen on the sample labels along the bottom (A, B, or C). Any white dots indicate the sample was distant from the axis between conditions, so the color should be interpreted with caution or investigated further. The most interesting results from GSEPD are here, when unclassified samples (Blood/C) are scored as similar to either of the tested conditions on a geneset-by-geneset basis. Both the Alpha table and Beta table are summarized in the HMA figure.}
    \label{fig:HMA}
\end{figure}

\begin{figure}[p]
    \centering
    \includegraphics[width=0.9\textwidth, type=pdf, ext=.pdf, read=.pdf]{OUT\Sexpr{.Platform$file.sep}GSEPD.HMG.Ax4.Bx8}
    \caption{OUT\textbackslash GSEPD.HMG.Ax4.Bx8.pdf is a simplified projection display summary heatmap from the comparison Ax4 vs Bx8. Here, as in a normal heatmap, your samples are columns, and rows are GO Terms with significant segregation ability. All rows and columns are arranged to cluster. The color in each cell represents the sample's Gamma(1/2) score for that GO Term, with blue indicating similarity to class `A', and the gold indicating similarity to class `B'. The unlabeled top row indicates the comparison categories, also seen on the sample labels along the bottom (A, B, or C). Black areas indicate the sample was distant from both conditions. The most interesting results from GSEPD are here, when unclassified samples (Blood/C) are scored as similar to either of the tested conditions on a geneset-by-geneset basis. Both the Gamma1 table and Gamma2 table are summarized in this HMG figure.}
    \label{fig:HMG}
\end{figure}



<<AlphaBetaTables, echo = FALSE, results = 'asis'>>=
Alpha_File <- read.csv("OUT/GSEPD.Alpha.Ax4.Bx8.csv",
                      header=TRUE,as.is=TRUE, nrows=20, row.names=1)
xT<-xtable(head(Alpha_File, n=10L)[,c(1,2,3,4,5,9,13)],
           caption ="First ten rows of OUT/GSEPD.Alpha.Ax4.Bx8.csv showing the group projection scores for each sample, these directly correspond to the colors in the HMA file. Where the HMA displays only significant sets, the Alpha table continues for all tested GO Terms. Both the Alpha table and Beta table are summarized in Figure \\ref{fig:HMA}.", label = 'TableAlpha')
print(xT, scalebox=0.80, include.rownames=TRUE)
Beta_File <- read.csv("OUT/GSEPD.Beta.Ax4.Bx8.csv",
                      header=TRUE,as.is=TRUE, nrows=20, row.names=1)
xT<-xtable(head(Beta_File, n=10L)[,c(1,2,3,4,5,9,13)],
           caption ="First ten rows of OUT/GSEPD.Beta.Ax4.Bx8.csv showing the linear divergence (distance to axis) for each sample, high values here would be annotated with white dots on the HMA file to indicate that a sample is not falling on the axis. Non-tested samples are expected to frequently have high values here, the C group was not part of the A vs B comparison.  Where the HMA displays only significant sets, the Beta table continues for all tested GO Terms. Both the Alpha table and Beta table are summarized in Figure \\ref{fig:HMA}.", label = 'TableBeta')
print(xT, scalebox=0.80, include.rownames=TRUE)
Gamma1_File <- read.csv("OUT/GSEPD.HMG1.Ax4.Bx8.csv",
                      header=TRUE,as.is=TRUE, nrows=20, row.names=1)
xT<-xtable(head(Gamma1_File, n=10L)[,c(1,2,3,4,5,9,13)],
           caption ="First ten rows of OUT/GSEPD.HMG1.Ax4.Bx8.csv showing the z-scaled distance to the Group1 centroid for each sample, these directly correspond to the colors in the HMG file. Where the HMG displays only significant sets, the Gamma table continues for all tested GO Terms. Both the Gamma1 and Gamma2 tables are summarized in Figure \\ref{fig:HMG}. Distance is normalized to dimensionality by scaling between the centroids. Thus a score of 0 means the sample resides on the centroid, and a score of 1 means it resides on the opposite class centroid, or equidistant.", label = 'TableGamma1')
print(xT, scalebox=0.80, include.rownames=TRUE)
Gamma2_File <- read.csv("OUT/GSEPD.HMG2.Ax4.Bx8.csv",
                      header=TRUE,as.is=TRUE, nrows=20, row.names=1)
xT<-xtable(head(Gamma2_File, n=10L)[,c(1,2,3,4,5,9,13)],
           caption ="First ten rows of OUT/GSEPD.HMG2.Ax4.Bx8.csv showing the z-scaled distance to the Group2 centroid for each sample, these directly correspond to the colors in the HMG file. Where the HMG displays only significant sets, the Gamma table continues for all tested GO Terms. Both the Gamma1 and Gamma2 tables are summarized in Figure \\ref{fig:HMG}. Distance is normalized to dimensionality by scaling between the centroids. Thus a score of 0 means the sample resides on the centroid, and a score of 1 means it resides on the opposite class centroid, or equidistant.", label = 'TableGamma2')
print(xT, scalebox=0.80, include.rownames=TRUE)
@



<<FindFiles, echo = FALSE, results = 'asis'>>=
HM_File <- list.files("OUT",pattern="HM.A")
PScatter_File <- list.files("OUT//SCGO",pattern="Scatter.Ax")[1]
PGSEPD_File <- list.files("OUT//SCGO",pattern="GSEPD.Ax")[1]
PPairs_File <- list.files("OUT//SCGO",pattern="Pairs.Ax")[1]
#trim the .PDF
HM_File <- substring(HM_File,0,nchar(HM_File)-4)
PScatter_File <- substring(PScatter_File,0,nchar(PScatter_File)-4)
PGSEPD_File <- substring(PGSEPD_File,0,nchar(PGSEPD_File)-4)
PPairs_File <- substring(PPairs_File,0,nchar(PPairs_File)-4)

@



\begin{figure}[p]
    \centering
    \includegraphics[height=0.75\textheight, type=pdf, ext=.pdf, read=.pdf]{OUT\Sexpr{.Platform$file.sep}\Sexpr{HM_File}}
    \caption{OUT\textbackslash \Sexpr{HM_File}.pdf is a heatmap of your comparisons with full expression details for those genes found 
    significantly expressed. The number of genes is given in the filename. 
    Each row is scaled such that the lowest values are blue and the highest are gold (default colors are changable in GSEPD\_INIT). 
    The numbers within each cell are the expression values as variance-stabilized normalized counts, similar to a log transform, provided by DESeq2. 
    Across the top, between the sample clustering dendrogram and the heatmap itself is a colorbar annotating which samples belong to which comparison group, 
    for this differential expression blue vs gold. 
    Black corresponds to extraneous samples, contributing context. 
    Other variations of this plot with less information are generated as HMS files (compared samples only) and HM- files (minimal figure without details). }
    \label{fig:HM}
\end{figure}



\begin{figure}[p]
    \centering
    \includegraphics[width=0.45\textwidth, type=pdf,  ext=.pdf, read=.pdf, page=1]{OUT\Sexpr{.Platform$file.sep}SCGO\Sexpr{.Platform$file.sep}\Sexpr{PGSEPD_File}}
    \caption{OUT\textbackslash SCGO\textbackslash \Sexpr{PGSEPD_File}.pdf First page of the projections file for one GO Term. All significant sets have this figure generated displaying the central axis between two groups as a black line (with ends annotated Ax4 and Bx8), and each sample's closest point along the line. These files have half as many pages as genes in the set, so we can display pairs as two-dimensional scatterplots. It's a workaround to the problem of displaying an N-dimensional scatterplot. For sets with fewer than 11 genes, full pairings are viewable with the Pairs file, Figure \ref{fig:PAIRS} }
    \label{fig:GSEPD}
\end{figure}

\begin{figure}[p]
    \centering
    \includegraphics[width=0.90\textwidth, type=pdf,  ext=.pdf, read=.pdf]{OUT\Sexpr{.Platform$file.sep}SCGO\Sexpr{.Platform$file.sep}\Sexpr{PPairs_File}}
    \caption{OUT\textbackslash SCGO\textbackslash \Sexpr{PPairs_File}.pdf The Pairs file is generated for significant GO terms with between two and ten genes, making it easy to review correlations or subgroups of gene expression among low-level gene sets.}
    \label{fig:PAIRS}
\end{figure}

\begin{figure}[p]
    \centering
    \includegraphics[width=0.45\textwidth, type=pdf,  ext=.pdf, read=.pdf]{OUT\Sexpr{.Platform$file.sep}SCGO\Sexpr{.Platform$file.sep}\Sexpr{PScatter_File}}
    \caption{OUT\textbackslash SCGO\textbackslash \Sexpr{PScatter_File}.pdf The Scatter file is similar to the PCA files, but the gene set is restricted to those within a given, significant, GO Term. As in the PCA file, genes driving the principle components are annotated along the axes. At the bottom of the figure, statistics are given pertaining to this group. All such data is available in tables, but this Scatter plot helps the user see which samples behave like which groups. Depending on the number of genes relative to the number of samples, different PCA formulas may be used. For a set with only two genes, this file can directly display the expression values as normalized counts, the same as found on the expression heatmap (Fig. \ref{fig:HM}.)}
    \label{fig:Scatter}
\end{figure}



\bibliography{rgsepd}

\section*{Session Info}
<<sessionInfo>>=
  sessionInfo()
@

\end{document}

\name{GSEPD_ChangeConditions}
\alias{GSEPD_ChangeConditions}

\title{GSEPD_ChangeConditions}
\description{
This function is an interface to set which samples are the test conditions. Don't forget to GSEPD_Process() after changing settings. If you want to systematically try each condition pairing, try GSEPD_ProcessAll() }
\usage{
GSEPD_ChangeConditions(GSEPD, newConditions)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{GSEPD}{Parameters object.}
  \item{newConditions}{ a two-item vector matching some of your sampleMeta$Conditions}
}
\details{ Interface will check if the conditions are known, then set the C2T value.}
\value{
  Returns the GSEPD parameter object with its mode set via the C2T and Conditions element of the named list. These tell later steps which sample conditions you intend on comparing.
}

\examples{
  data("IlluminaBodymap")
  data("IlluminaBodymapMeta")
  set.seed(1000) #fixed randomness
  isoform_ids <- Name_to_RefSeq(c("HIF1A","EGFR","MYH7","CD33","BRCA2"))
  rows_of_interest <- unique( c( isoform_ids ,
                                 sample(rownames(IlluminaBodymap),
                                        size=2000,replace=FALSE)))
  G <- GSEPD_INIT(Output_Folder="OUT",
                finalCounts=round(IlluminaBodymap[rows_of_interest , ]),
                sampleMeta=IlluminaBodymapMeta,
                COLORS=c("green","black","red"))
        ConditionsToTest <- c("A","B")
  G <- GSEPD_ChangeConditions( G, ConditionsToTest  )
  #G <- GSEPD_Process( G ) #would test samples A vs samples B
  G <- GSEPD_ChangeConditions( G, c("A","C"))
  #G <- GSEPD_Process( G ) #would test samples A vs samples C
}

\seealso{ GSEPD_Example }

\name{rgsepd-package}
\alias{rgsepd-package}
\alias{rgsepd}
\docType{package}
\title{
R/Gene Set Enrichment and Projection Displays
}
\description{
R/GSEPD is a Bioinformatics package for the R programming environment that helps you disambiguate transcriptome samples (Human RNA-Seq at RefSeq IDs) by automating differential expression (DESeq), then gene set enrichment (GOSeq hg19), and finally a N-dimensional projection to quantify in which ways each sample is like either treatment group. Many exploratory tables and plots are generated for you to browse the behavior of your samples in various gene-sets (defined by GO). Sets which significantly segregate your sample conditions by bootstrapped k-means are further explored.

See the Vignette for usage examples, and minimal examples within each function's reference.
}
\details{
\tabular{ll}{
Package: \tab rgsepd\cr
Type: \tab Package\cr
Version: \tab 1.15\cr
Date: \tab 2019-01-05\cr
License: \tab GPL-3\cr
}

}
\author{
Karl D. Stamm PhD <karl.stamm@gmail.com>
}
\references{
Initially a wrapper for DESeq2 and GOSeq, late-stage processing continues with a unique geneset based sample clustering. }
\keyword{ package }
\seealso{

Example data is public human RNA-Seq from Illumina Human Bodymap2 project, aligned to GRCh37 by Ensembl and downloaded from ftp://ftp.ensembl.org/pub/release-70/bam/homo_sapiens/genebuild/ then read counts are collected by coverageBed using RefSeq.GTF. We downloaded Adipose,Blood,Heart and Skeletal Muscle, and downsampled each to one third to create artificial replicates. 

See the Vignette for usage walkthrough and results summaries.

}
\examples{
  data("IlluminaBodymap")
  data("IlluminaBodymapMeta")
  set.seed(1000) #fixed randomness
  isoform_ids <- Name_to_RefSeq(c("HIF1A","EGFR","MYH7","CD33","BRCA2"))
  rows_of_interest <- unique( c( isoform_ids ,
                                 sample(rownames(IlluminaBodymap),
                                        size=2000,replace=FALSE)))
  G <- GSEPD_INIT(Output_Folder="OUT",
                finalCounts=round(IlluminaBodymap[rows_of_interest , ]),
                sampleMeta=IlluminaBodymapMeta,
                COLORS=c("green","black","red"))     
  G <- GSEPD_ChangeConditions( G, c("A","B"))
 # G <- GSEPD_Process( G ) #would run DESeq2 and GOSeq and GSEPD comparing conditions A and B
 
}

\name{GSEPD_PullDEG}
\alias{GSEPD_PullDEG}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Pull Differentially Expressed Genes}
\description{
After processing, if you want to easily access the differentially expressed transcript listing, this function will read in the default generated files, and apply filters as specified by the GSEPD master object (default p-values). }
\usage{
GSEPD_PullDEG(GSEPD, PTHRESH)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{GSEPD}{
The master object should have been processed already such that differentially expressed genes are readily available.}
  \item{PTHRESH}{
Specify the degree of stringency.}
}
\examples{
  data("IlluminaBodymap")
  data("IlluminaBodymapMeta")
  set.seed(1000) #fixed randomness
  isoform_ids <- Name_to_RefSeq(c("HIF1A","EGFR","MYH7","CD33","BRCA2"))
  rows_of_interest <- unique( c( isoform_ids ,
                                 sample(rownames(IlluminaBodymap),
                                        size=2000,replace=FALSE)))
  G <- GSEPD_INIT(Output_Folder="OUT",
                finalCounts=round(IlluminaBodymap[rows_of_interest , ]),
                sampleMeta=IlluminaBodymapMeta,
                COLORS=c("green","black","red"))
  G <- GSEPD_ChangeConditions( G, c("A","B")) #set testing groups first!   
  G <- GSEPD_Process( G ) #have to have processed results to plot them
  
  Significant_Genes <- GSEPD_PullDEG(G, PTHRESH=0.0250)
  #then do more with these identifiers:
  print(Significant_Genes)
  # GSEPD_Heatmap(G, genes= Significant_Genes )
  
}
\value{
Returns a vector of ID#, suitable to row-subsetting of the finalCounts table.
}

\name{GSEPD_DEGHeatmap}
\alias{GSEPD_DEGHeatmap}

\title{
 Differentially Expressed Genes Heatmap 
}
\description{
 Generates a gene-by-subject heatmap plot of differentially expressed genes.
 }
\usage{
 GSEPD_DEGHeatmap(G)
}
\arguments{
  \item{G}{
  The GSEPD master object carries sample information and gene expression data. It should have already run Process() to be eligible.  Parameters regarding differential expression limits are set within the G$LIMIT list object. 
 }
}
\details{
 After GSEPD_Process() has created differential expression tables with known filenames, this function can read those tables and make heatmap plots for a subset of genes.  We use the N most significant genes, specified by the \code{MAX_Genes_for_Heatmap} parameter of the passed GSEPD object.
}
\value{
 This function doesn't return anything. If successful, four PDF files are created. HM and HM- are all subjects from sampleMeta and finalCounts, HMS and HMS- are only those in the test groups. The hyphen indicates a smaller unlabeled figure. In each case the data is manipulated as in \code{GSEPD_Heatmap()} such that complete linkage clustering is performed on z-score normalized genes using the normalized counts directly from DESeq2::varianceStabilizingTransformation, which are displayed in the labeled figures. 
}
\examples{
  data("IlluminaBodymap")
  data("IlluminaBodymapMeta")
  set.seed(1000) #fixed randomness
  isoform_ids <- Name_to_RefSeq(c("HIF1A","EGFR","MYH7","CD33","BRCA2"))
  rows_of_interest <- unique( c( isoform_ids ,
                                 sample(rownames(IlluminaBodymap),
                                        size=2000,replace=FALSE)))
  G <- GSEPD_INIT(Output_Folder="OUT",
                finalCounts=round(IlluminaBodymap[rows_of_interest , ]),
                sampleMeta=IlluminaBodymapMeta,
                COLORS=c("green","black","red"))    
  G <- GSEPD_ChangeConditions( G, c("A","B")) #set testing groups first!
  G <- GSEPD_Process( G ) #have to have processed results to plot them
  GSEPD_DEGHeatmap(G) # all parameters automatic
  
}
\keyword{ plot }

\name{DisplayName}
\alias{DisplayName}

\title{
DisplayName}
\description{
Convert a transcript id number to the corresponding gene name, where available.}
\usage{
DisplayName(txid)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{txid}{
The transcript id number, or a vector thereof.}
}

\value{
The gene's human-readable name.
}

\note{
Uses org.Hs.eg.db and pulls the first Entrez Gene ID, then that ID's associated HGNC.}

\examples{
  DisplayName("NM_005228")
}

\name{GSEPD_Process}
\alias{GSEPD_Process}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Processing}
\description{Primary interface, use this function to kick off the pipeline.}
\usage{
GSEPD_Process(GSEPD)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{GSEPD}{
The initialized GSEPD master object to operate on.}
}
\details{
Runs the pipeline. If any files are already present matching the generated filenames, they will be reused. If you changed a parameter that would alter the generated filenames, new ones are created. If a customization parameter is not part of the filename (like a p-value cutoff), you should change the output folder to keep new files separate.}
\value{
Returns the GSEPD object post-processed, for use in further plotting functions. Optional.
}
\examples{
  data("IlluminaBodymap")
  data("IlluminaBodymapMeta")
  set.seed(1000) #fixed randomness
  isoform_ids <- Name_to_RefSeq(c("HIF1A","EGFR","MYH7","CD33","BRCA2"))
  rows_of_interest <- unique( c( isoform_ids ,
                                 sample(rownames(IlluminaBodymap),
                                        size=2000,replace=FALSE)))
  G <- GSEPD_INIT(Output_Folder="OUT",
                finalCounts=round(IlluminaBodymap[rows_of_interest , ]),
                sampleMeta=IlluminaBodymapMeta,
                COLORS=c("green","black","red"))
  G <- GSEPD_ChangeConditions( G, c("A","B")) #set testing groups first!   
  #G <- GSEPD_Process( G ) #would run DESeq2 and GOSeq and GSEPD comparing conditions A and B
 
}

\seealso{GSEPD_INIT}

\name{ExtractProjection}
\alias{ExtractProjection}
\title{
ExtractProjection
}
\description{
This function takes a completed GSEPD object with sample data, and a set of gene identifiers and produces the projection of sample expression in the sub-space. 
}
\usage{
ExtractProjection(GSEPD, txids, DRAWING=FALSE, GN=c(1,2), PRINTING=FALSE, plotTitle="")
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{GSEPD}{The GSEPD parameter object. Must be post-Process.}
  \item{txids}{The transcript IDs, generally REFSEQ identifiers corresponding to rows of the counts table for this a projection is desired. In normal usage these are based on a GO Term. }
  \item{DRAWING}{ Boolean flag to draw a plot of the projection.  }
  \item{GN}{ The gene numbers: which items of the 'txids' list are to be drawn. Only the first two are used. If Drawing=FALSE, this parameter is irrelevant.}
  \item{PRINTING}{ Boolean flag to print some debug information. }
  \item{plotTitle}{ A name for this set of genes, serves as the plot's main title. }
  
}

\details{

 Primary gene set projection tool. This function calculates the vector projection and axis in a N-dimensional space of gene expression for a set of samples. When DRAWING=TRUE you will get some diagrams of the expression normalized counts. 
}

\value{
Returns a list object with four values for each sample. 
  \item{alpha}{ Distance along the axis from group1 to group2, generally 0-1, as in percent. Samples within group 1 should average zero, and samples in group 2 should average one. }
  \item{beta}{ Distance from the samples to the axis. This is a measure of goodness of fit, when the value is zero it means the sample is a linear interpolation between the comparison groups. When the value is high, the sample is not along the n-dimensional axis. }
  \item{gamma1}{ Distance from the samples to the center of group1 }
  \item{gamma2}{ Distance from the samples to the center of group2 }
  \item{Validity.Score}{ A score, 0\% through 100\%, of the segregation validity for this gene set among the two sample test groups. }
  \item{Validity.P}{ The validity score's associated p-value, empirically calculated chance of a random sample assignment creating such a strong score. }

}

\examples{

  data("IlluminaBodymap")
  data("IlluminaBodymapMeta")
  set.seed(1000) #fixed randomness
  x <- Name_to_RefSeq(c("HIF1A","EGFR","MYH7","CD33","BRCA2"))
  isoform_ids = intersect(x, rownames(IlluminaBodymap))
  rows_of_interest <- unique( c( isoform_ids ,
                                 sample(rownames(IlluminaBodymap),
                                        size=2000,replace=FALSE)))
  G <- GSEPD_INIT(Output_Folder="OUT",
                finalCounts=round(IlluminaBodymap[rows_of_interest , ]),
                sampleMeta=IlluminaBodymapMeta,
                COLORS=c("green","black","red"))
                
  G <- GSEPD_ChangeConditions( G, c("A","B")) #set testing groups first!    
  G <- GSEPD_Process( G ) #have to have processed results to plot them
   
   # looking at genes 2 and 3 will show us a view in dimensions "EGFR" and "MYH7"
   # and an axis through five dimensional space.
  ExtractProjection(GSEPD=G, txids=isoform_ids, 
    DRAWING=TRUE, PRINTING=TRUE, GN=c(2,3))
  
}

\keyword{ plot }

\name{IlluminaBodymapMeta}
\alias{IlluminaBodymapMeta}
\docType{data}
\title{
Metadata table for the included sample data
}
\description{
  The metadata table required to inform GSEPD of the sample/condition and abbreviated names for each column of the included 'counts' dataset. You should mirror this table's structure for your dataset. 
}
\usage{data(IlluminaBodymapMeta)}
\format{
  A data frame with 16 observations on the following 3 variables.
  \describe{
    \item{\code{Sample}}{A vector of the column names in your counts table, for the included sample data, it's four tissue types repeated four times each. For your data this must correspond to the column labels in the counts table.}
    \item{\code{Condition}}{The sample categorizations for use in differential expression, this should also be a vector the same length as the number of columns in your counts table. Here we have 'A' for each Adipose, 'B' for each muscle type, and 'C' for the blood samples.}
    \item{\code{SHORTNAME}}{Abbreviated names for each sample to appear in plots.}
  }
}
\value{
 A dataframe of sample identifiers for the rgsepd::IlluminaBodymap matrix.
}
\examples{
data(IlluminaBodymapMeta)
str(IlluminaBodymapMeta) 
}
\keyword{datasets}

\name{GSEPD_ChangeOutput}
\alias{GSEPD_ChangeOutput}

\title{GSEPD_ChangeOutput}
\description{
Update the stored output folder designation, and create it if necessary. This is useful if you want to change some LIMIT parameters and re-run the pipeline. Don't forget to GSEPD_Process() after changing settings.}
\usage{
GSEPD_ChangeOutput(GSEPD, newFolder)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{GSEPD}{
The initial GSEPD parameter object to update the output folder of.}
  \item{newFolder}{
The new output folder to be created.}
}
\value{
Returns the updated GSEPD parameter object.
}

\examples{

  data("IlluminaBodymap")
  data("IlluminaBodymapMeta")
  set.seed(1000) #fixed randomness
  isoform_ids <- Name_to_RefSeq(c("HIF1A","EGFR","MYH7","CD33","BRCA2"))
  rows_of_interest <- unique( c( isoform_ids ,
                                 sample(rownames(IlluminaBodymap),
                                        size=2000,replace=FALSE)))
  G <- GSEPD_INIT(Output_Folder="OUT",
                finalCounts=round(IlluminaBodymap[rows_of_interest , ]),
                sampleMeta=IlluminaBodymapMeta,
                COLORS=c("green","black","red"))
  G <- GSEPD_ChangeConditions( G, c("A","B")) #set testing groups first!           

  G<- GSEPD_ChangeOutput(G, "Output2")
  #G <- GSEPD_Process( G ) #would output to folder Output2
  #now tweak some settings and re-do
  G$LIMIT$LFC <- 0.25 #lower than default log-fold-change limit
  G<- GSEPD_ChangeOutput(G, "Output-Low")
  #G <- GSEPD_Process( G ) #would output to folder Output-Low

}


\author{
karl.stamm@gmail.com
}

\name{GSEPD_PCA_Spec}
\alias{GSEPD_PCA_Spec}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Specialized PCA Plot}
\description{After processing the pipeline, users may want to have further PCA figures generated. This function takes a completed GSEPD object and generates informative figures. This function includes parameters to specify a particular GO-Term of interest.}
\usage{
GSEPD_PCA_Spec(GSEPD, GOT, MDATA = NULL, customColors=FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{GSEPD}{
The master GSEPD object, post-processed.}
  \item{GOT}{
The GO-Term you'd like to specifically analyse. It should be found in the .MERGE file.}
  \item{MDATA}{
Optionally, pass in the .MERGE dataset, if missing, we'll try to read the already-processed file from the output directory. This option exists because reading that file repeatedly is quite slow, so you're recommended to read it in once in advance if you intend on making more than a couple GO-Term specific plots.}
  \item{customColors}{
a boolean value, when FALSE, default behavior is to color points to match the test conditions. When TRUE, use sampleMeta$CustomColor column for a sample-by-sample user specification. This behavior disables the built-in legend. }
}
\value{ No return value. Generates files.}
\note{
This function uses either princomp() or prcomp() as neccesary, depending on sample count vs gene count.}
\examples{
  data("IlluminaBodymap")
  data("IlluminaBodymapMeta")
  set.seed(1000) #fixed randomness
  isoform_ids <- Name_to_RefSeq(c("HIF1A","EGFR","MYH7","CD33","BRCA2"))
  rows_of_interest <- unique( c( isoform_ids ,
                                 sample(rownames(IlluminaBodymap),
                                        size=2000,replace=FALSE)))
  G <- GSEPD_INIT(Output_Folder="OUT",
                finalCounts=round(IlluminaBodymap[rows_of_interest , ]),
                sampleMeta=IlluminaBodymapMeta,
                COLORS=c("green","black","red"))
  G <- GSEPD_ChangeConditions( G, c("A","B")) #set testing groups first!    
  G <- GSEPD_Process( G ) #have to have processed results to plot them
  
  GOT <- "GO:0012345" # specify a GO Term you'd like to review
  
  #it should be present in the MERGE file.
  MergeFile <- list.files(G$Output_Folder, pattern="MERGE")[1]
  MDATA<-read.csv(sprintf("\%s\%s\%s", G$Output_Folder, .Platform$file.sep, MergeFile),
      as.is=TRUE,header=TRUE)
      
  GOT=MDATA$category[1] #choose a GO term that is definitely in the output data.
  
  GSEPD_PCA_Spec(G, GOT,MDATA=MDATA) 
}
\seealso{
GSEPD_PCA_Plot}

\name{GSEPD_Export_DESeq}
\alias{GSEPD_Export_DESeq}
\title{
Export DESeqDataSet object}
\description{
Converts from the internal matrices to a DESeq standard object. 
}
\usage{
GSEPD_Export_DESeq(G)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{G}{
 The GSEPD list object to extract a DeseqDataSet from.}
}
\details{
 Using the given GSEPD object's finalCounts and sampleMeta, a simple DESeqDataSet object is created with the default design matrix. Provided for interoperability with other analysis packages.}
\value{
an object of class DESeqDataSet
}
\references{
DESeq2 }

\examples{
  data("IlluminaBodymap")
  data("IlluminaBodymapMeta")
  set.seed(1000) #fixed randomness
  isoform_ids <- Name_to_RefSeq(c("HIF1A","EGFR","MYH7","CD33","BRCA2"))
  rows_of_interest <- unique( c( isoform_ids ,
                                 sample(rownames(IlluminaBodymap),
                                        size=2000,replace=FALSE)))
  G <- GSEPD_INIT(Output_Folder="OUT",
                finalCounts=round(IlluminaBodymap[rows_of_interest , ]),
                sampleMeta=IlluminaBodymapMeta,
                COLORS=c("green","black","red"))    
  G <- GSEPD_ChangeConditions( G, c("A","B")) #set testing groups first!           
  dds <- GSEPD_Export_DESeq(G)
  print(dds)
}

\keyword{ DESeq2 }

\name{GSEPD_PCA_Plot}
\alias{GSEPD_PCA_Plot}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Principle Components Analysis figure generation}
\description{After processing the pipeline, users may want to have further PCA figures generated. This function takes a completed GSEPD object and generates informative figures, based on the differentially expressed genes.}
\usage{
GSEPD_PCA_Plot(GSEPD, customColors=FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{GSEPD}{
The master object, it should have already been run through GSEPD_Process().}
  \item{customColors}{
a boolean value, when FALSE, default behavior is to color points to match the test conditions. When TRUE, use sampleMeta$CustomColor column for a sample-by-sample user specification. This behavior disables the built-in legend. }
}
\value{ No return value. Generates files.}


\examples{
  data("IlluminaBodymap")
  data("IlluminaBodymapMeta")
  set.seed(1000) #fixed randomness
  isoform_ids <- Name_to_RefSeq(c("HIF1A","EGFR","MYH7","CD33","BRCA2"))
  rows_of_interest <- unique( c( isoform_ids ,
                                 sample(rownames(IlluminaBodymap),
                                        size=2000,replace=FALSE)))
  G <- GSEPD_INIT(Output_Folder="OUT",
                finalCounts=round(IlluminaBodymap[rows_of_interest , ]),
                sampleMeta=IlluminaBodymapMeta,
                COLORS=c("green","black","red"))
  G <- GSEPD_ChangeConditions( G, c("A","B")) #set testing groups first!           
  G <- GSEPD_Process( G ) #have to have processed results to plot them
  GSEPD_PCA_Plot(G)
  
}

\seealso{
GSEPD_PCA_Spec}

\name{GSEPD_ProcessAll}
\alias{GSEPD_ProcessAll}

\title{GSEPD_ProcessAll}

\description{
 Runs each pairing within GSEPD$sampleMeta$Conditions. }
\usage{
GSEPD_ProcessAll(G)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{G}{ The GSEPD object from GSEPD_INIT() }
}
\details{ Set your GSEPD$LIMIT before running each pairwise comparison.}
\value{ Returns the last GSEPD object.}


\examples{
  data("IlluminaBodymap")
  data("IlluminaBodymapMeta")
  head(IlluminaBodymap)
  set.seed(1000) #fixed randomness
  isoform_ids <- Name_to_RefSeq(c("HIF1A","EGFR","MYH7","CD33","BRCA2"))
  rows_of_interest <- unique( c( isoform_ids ,
                                 sample(rownames(IlluminaBodymap),
                                        size=2000,replace=FALSE)))
  G <- GSEPD_INIT(Output_Folder="OUT",
                finalCounts=round(IlluminaBodymap[rows_of_interest , ]),
                sampleMeta=IlluminaBodymapMeta,
                COLORS=c("green","black","red"))    
                
#  G <- GSEPD_ProcessAll( G ) #would run across all pairs of G$Condition

}


\seealso{
GSEPD_Process

}

\name{Name_to_RefSeq}
\alias{Name_to_RefSeq}

\title{
Name to RefSeq}
\description{
Lookup a HGNC symbol and return an appropriate NM##.}
\usage{
Name_to_RefSeq(x)
}
\arguments{
  \item{x}{
The HGNC symbol(s) you wish to convert.}
}
\details{
Not found gene symbols will return NA or the empty string.  }
\value{
The NM_### id numbers corresponding to the input gene names (HGNC symbols.)
}

\note{
This routine relies on bioconductor annotation package org.Hs.eg.db to ensure the most up to date mappings. 
A few years after writing this function, some gene names have had their primary transcript ID changed to a new one. It's not in the old bundled dataset, and some scripts are not running properly anymore. Will have to update the dataset or use a more modern version. }

\examples{

 Name_to_RefSeq("LSMEM2")
 #should return NM_153215
}

\name{GSEPD_Heatmap}
\alias{GSEPD_Heatmap}
\title{
GSEPD_Heatmap
}
\description{
Plots the heatmap to the standard display. Uses heatmap.2 from gplots to display selected genes' expression level.
}
\usage{
GSEPD_Heatmap(G,genes,cap_range=3,cellnote="log10")
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{G}{The GSEPD parameter object. Must be post Process.}
  \item{genes}{rownames of finalCounts, usually isoform ID#s.}
  \item{cap_range}{z-score of most extreme color}
  \item{cellnote}{display the log10 values in each cell. No other options are supported.}
  
}

\details{
Will use GSEPD$COLORFUNCTION scaled between samples of type GSEPD$Conditions in GSEPD$sampleMeta, including others in the mix. The heatmap's dendrograms (margin trees) are computed by the heatmap.2() function's default method hclust() on the supplied data, resulting in complete linkage heirarchical clustering. Because the magnitude of gene expression varies across a wide range, and we're interested in patterns more than scale, we first normalize each gene(row) by subtracting the mean, dividing by the standard deviation, and capping the min and max to the parameter cap_range=3. The heatmap function is run with no further scaling, ensuring genes with similar differential expression profiles are clustered together. The numbers written in each cell of the heatmap are simply the normalized counts directly from DESeq2::varianceStabilizingTransformation. 
}

\value{
No return value: generates a figure.
}

\examples{

  data("IlluminaBodymap")
  data("IlluminaBodymapMeta")
  set.seed(1000) #fixed randomness
  x <- Name_to_RefSeq(c("HIF1A","EGFR","MYH7","CD33","BRCA2"))
  isoform_ids = intersect(x, rownames(IlluminaBodymap))
  rows_of_interest <- unique( c( isoform_ids ,
                                 sample(rownames(IlluminaBodymap),
                                        size=2000,replace=FALSE)))
  G <- GSEPD_INIT(Output_Folder="OUT",
                finalCounts=round(IlluminaBodymap[rows_of_interest , ]),
                sampleMeta=IlluminaBodymapMeta,
                COLORS=c("green","black","red"))
                
  G <- GSEPD_ChangeConditions( G, c("A","B")) #set testing groups first!    
  G <- GSEPD_Process( G ) #have to have processed results to plot them
  
  GSEPD_Heatmap(G, genes=sample(rownames(G$finalCounts),8) )
  
}

\keyword{ heatmap }
\keyword{ plot }

\name{GSEPD_INIT}
\alias{GSEPD_INIT}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Initialization}
\description{Initializes the system, here you will pass in the count dataset and the sample metadata, before any GSEPD processing. Return value is a named list holding configurable parameters. }
\usage{
GSEPD_INIT(Output_Folder = "OUT", finalCounts = NULL, sampleMeta = NULL,
DESeqDataSet = NULL, renormalize = TRUE, vstBlind=TRUE,
  COLORS = c("green", "gray", "red"),
  C2T = "x" )
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{Output_Folder}{ Specify the subdirectory to hold output/generated files. Defaults to "OUT".}
  \item{finalCounts}{This must be a matrix of count data, rows are transcript IDs and columns are samples.}
  \item{sampleMeta}{The sampleMeta matrix must be passed here. It is a data frame with a row for each sample in the finalCounts matrix. Some required columns are SHORTNAME= sample nicknames; Condition= treatment group for differential expression; and Sample are the column names of finalCounts. Other columns are permitted to facilitate subsetting (not automatically supported).}
  \item{DESeqDataSet}{Data may also be included in the format of a DESeqDataSet object, this is mutually exclusive of the finalCounts/sampleMeta scheme.}
  \item{renormalize}{Boolean performance flag. Default is TRUE, which causes a normalized counts table to be computed from your given raw reads 'finalCounts'. If you set this to FALSE, then the normCounts table is preloaded with the given finalCounts input matrix, short circuiting the built-in DESeq VST, and allowing the user to specify some sort of pre-normalized dataset.}
  \item{vstBlind}{Exposes the option from DESeq2 to change the way varianceStabilizingTransformation works. According to the DESeq manual: blind=TRUE should be used for comparing samples in an manner unbiased by prior information on samples ... If many of genes have large differences in counts due to the experimental design, it is important to set blind=FALSE for downstream analysis.}
  \item{COLORS}{A three element vector of colors to make the heatmaps, the first element is the under-expressed genes, and the third element is the over-expressed genes. Defaults to green-red through gray.}
  \item{C2T}{This symbol is used in the filenames to delimit sample groups.}
  
}
\details{This function sets up the master parameter object, and therefore must be called first. This object includes all configurable parameters you can change before running the pipeline. Count data should be provided in the finalCounts matrix, with phenotype and sample data in the sampleMeta matrix. Optionally, these data may be packages in a DESeqDataSet instead. Rows with no expression are dropped at the point of loading.}
\value{Returns the GSEPD named list master object, to be used in subsequent function calls.}

\examples{
  data("IlluminaBodymap")
  data("IlluminaBodymapMeta")
  isoform_ids <- Name_to_RefSeq(c("HIF1A","EGFR","MYH7","CD33","BRCA2"))
  rows_of_interest <- unique( c( isoform_ids ,
                                 sample(rownames(IlluminaBodymap),
                                        size=2000,replace=FALSE)))
  G <- GSEPD_INIT(Output_Folder="OUT",
                finalCounts=round(IlluminaBodymap[rows_of_interest , ]),
                sampleMeta=IlluminaBodymapMeta,
                COLORS=c("green","black","red"))   
  #now ready to run:
  # G<-GSEPD_ProcessAll(G);
  
}

\seealso{GSEPD_Process}

\name{IlluminaBodymap}
\alias{IlluminaBodymap}
\docType{data}
\title{
 Sample RNA-Seq Counts data
}
\description{
 A collection of counts datasets from Illumina Human Bodymap 2.0, one sample each for adipose, blood, heart and skeletal_muscle. Four technical replicates are created by downsampling the original Illumina data. Alignment was performed by Ensembl, so the source of this dataset is ftp://ftp.ensembl.org/pub/release-70/bam/homo_sapiens/genebuild . Each of the four Human Bodymap samples are downsampled four times. Read counts are collected with Bedtools CoverageBed and a RefSeq exon annotation.    
}
\usage{data(IlluminaBodymap)}
\format{
  A data frame with 37653 observations on the following 16 variables.
  \describe{
    \item{\code{adipose.1}}{Illumina Human Bodymap 2 'Adipose' sample, downsampled to one-third. }
    \item{\code{adipose.2}}{Illumina Human Bodymap 2 'Adipose' sample, downsampled to one-third. }
    \item{\code{adipose.3}}{Illumina Human Bodymap 2 'Adipose' sample, downsampled to one-third. }
    \item{\code{adipose.4}}{Illumina Human Bodymap 2 'Adipose' sample, downsampled to one-third. }
    \item{\code{blood.1}}{Illumina Human Bodymap 2 'Blood' sample, downsampled to one-third. }
    \item{\code{blood.2}}{Illumina Human Bodymap 2 'Blood' sample, downsampled to one-third. }
    \item{\code{blood.3}}{Illumina Human Bodymap 2 'Blood' sample, downsampled to one-third. }
    \item{\code{blood.4}}{Illumina Human Bodymap 2 'Blood' sample, downsampled to one-third. }
    \item{\code{heart.1}}{Illumina Human Bodymap 2 'Heart' sample, downsampled to one-third. }
    \item{\code{heart.2}}{Illumina Human Bodymap 2 'Heart' sample, downsampled to one-third. }
    \item{\code{heart.3}}{Illumina Human Bodymap 2 'Heart' sample, downsampled to one-third. }
    \item{\code{heart.4}}{Illumina Human Bodymap 2 'Heart' sample, downsampled to one-third. }
    \item{\code{skeletal_muscle.1}}{Illumina Human Bodymap 2 'Skeletal Muscle' sample, downsampled to one-third. }
    \item{\code{skeletal_muscle.2}}{Illumina Human Bodymap 2 'Skeletal Muscle' sample, downsampled to one-third.}
    \item{\code{skeletal_muscle.3}}{Illumina Human Bodymap 2 'Skeletal Muscle' sample, downsampled to one-third.}
    \item{\code{skeletal_muscle.4}}{Illumina Human Bodymap 2 'Skeletal Muscle' sample, downsampled to one-third.}
  }
}
\value{
 A numeric matrix of read-counts from RNA-Seq, measured at transcripts by coverageBed.
}
\source{
 http://www.ebi.ac.uk/arrayexpress/experiments/E-MTAB-513/
}
\references{
 Illumina Human Bodymap 2.0. Ensembl etc.
 }
\examples{
data(IlluminaBodymap)
head(IlluminaBodymap,30)

}
\keyword{datasets}
